// Kaze, 2013-Jul-10

//for xxhash:
#include "stddef.h"
//#include "stdint.h"
#include "string.h"

#include <emmintrin.h>
#include <smmintrin.h> //4.1
#include <immintrin.h> //AVX

//inline void SlowCopy128bit (const char *SOURCE, const char *TARGET) { _mm_storeu_si128((__m128i *)(TARGET), _mm_loadu_si128((const __m128i *)(SOURCE))); }

#define xmmload(p) _mm_load_si128((__m128i const*)(p))
// 16byte aligned down:
// _mm_loadu_si128
// _mm_storeu_si128
#define xmmloadu(p) _mm_loadu_si128((__m128i const*)(p))

// -D_gcc_mumbo_jumbo_
// Change accordingly from command line:
#define _icl_mumbo_jumbo_

#if defined(_icl_mumbo_jumbo_)
// GetRDTSC() taken from strchr.com
#if defined(_M_IX86)
unsigned long long __forceinline GetRDTSC(void) {
   __asm {
      ; Flush the pipeline
      XOR eax, eax
      CPUID
      ; Get RDTSC counter in edx:eax
      RDTSC
   }
}
#elif defined(_M_X64)
unsigned long long __forceinline GetRDTSC(void) {
	return __rdtsc();
}
#else
unsigned long long __forceinline GetRDTSC(void) {
	return GetTickCount();
}
#endif
#endif


//0x82608EDB // The IEEE 802.3 standard: HD=6 for 172-268; HD=8 for 58-91
//0x8F6E37A0 // Castagnoli (iSCSI): HD=6 for 178-5243; HD=8 for 48-177
//0xBA0DC66B // Koopman: HD=6 for 153-16360; HD=8 for 19-152
//0x90022004 // Koopman: HD=6!!! for 8!!!-32738

//CRC-32 HDLC, ANSI X3.66, ITU-T V.42, Ethernet, Serial ATA, MPEG-2, PKZIP, Gzip, Bzip2, PNG,[24] many others) 	0x04C11DB7 / 0xEDB88320 / 0x82608EDB[10]
//CRC-32C (Castagnoli) iSCSI, SCTP, G.hn payload, SSE4.2, Btrfs, ext4						1EDC6F41 / 0x82F63B78 / 0x8F6E37A0[10]
//CRC-32K (Koopman)												741B8CD7 / 0xEB31D82E / 0xBA0DC66B[10]

/*
E:\Knight-tour_r8dump_Yorikke_CRC8>cl /Ox Knight-tour_r8dump_Yorikke_CRC8.c
Microsoft (R) 32-bit C/C++ Optimizing Compiler Version 16.00.30319.01 for 80x86
Copyright (C) Microsoft Corporation.  All rights reserved.

Knight-tour_r8dump_Yorikke_CRC8.c
Microsoft (R) Incremental Linker Version 10.00.30319.01
Copyright (C) Microsoft Corporation.  All rights reserved.

/out:Knight-tour_r8dump_Yorikke_CRC8.exe
Knight-tour_r8dump_Yorikke_CRC8.obj

E:\Knight-tour_r8dump_Yorikke_CRC8>Knight-tour_r8dump_Yorikke_CRC8.exe a8 10000000
Knight-tour_r8dump_Yorikke, subrevision B, written by Kaze (based on Kurt White's code), downloadable at www.sanmayce.com/Fastest_Hash
Purpose: to compare FNV1A_Yorikke and CRC32 by giving the highest number of collisions i.e. the deepest nest/layer, the-lesser-the-better.
Polynomial used:
#define CRCPOLY 0xEDB88320 // CRC32
#define CRCPOLYC 0x82F63B78 // CRC32C
#define CRCINIT 0xFFFFFFFF
KT to be hashed = 00,010,000,000
HashSizeInBits = 7
ReportAtEvery = 1,000,000
Allocating HASH memory 0MB ... OK
Allocating HASH memory 0MB ... OK
Allocating HASH memory 0MB ... OK
FNV1A_Yorikke: KT_DumpCounter = 00,001,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 008,052; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,001,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 008,051; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,001,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 008,026; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,002,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 015,966; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,002,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 015,897; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,002,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 015,938; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,003,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 023,893; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,003,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 023,730; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,003,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 023,720; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,004,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 031,632; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,004,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 031,652; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,004,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 031,661; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,005,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 039,520; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,005,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 039,395; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,005,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 039,617; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,006,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 047,476; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,006,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 047,406; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,006,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 047,389; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,007,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 055,399; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,007,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 055,169; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,007,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 055,204; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,008,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 063,205; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,008,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 063,166; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,008,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 063,063; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,009,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 070,992; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,009,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 070,937; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,009,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 070,829; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,010,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 078,922; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,010,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 078,942; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,010,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 078,631; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%

E:\Knight-tour_r8dump_Yorikke_CRC8>
*/

#include <windows.h>

#include <stdint.h> // uint8_t needed
//typedef unsigned char uint8_t;
//typedef unsigned short uint16_t;
//typedef unsigned int uint32_t;

#define _rotl_KAZE(x, n) (((x) << (n)) | ((x) >> (32-(n))))
#define _rotl_KAZE64(x, n) (((x) << (n)) | ((x) >> (64-(n))))
	//extern __m128i __ICL_INTRINCC _mm_and_si128(__m128i, __m128i);
	//extern __m128i __ICL_INTRINCC _mm_andnot_si128(__m128i, __m128i);
	//extern __m128i __ICL_INTRINCC _mm_or_si128(__m128i, __m128i);
	//extern __m128i __ICL_INTRINCC _mm_xor_si128(__m128i, __m128i);
#define _rotl_KAZE128(x, n) _mm_or_si128(_mm_slli_si128(x, n) , _mm_srli_si128(x, 128-n))
	//extern __m128i __ICL_INTRINCC _mm_slli_si128(__m128i, int);
	//extern __m128i __ICL_INTRINCC _mm_srli_si128(__m128i, int);


#define HashSizeInBits 26 //256MB
#define ReportAtEvery (1<<HashSizeInBits)-1 //1000000

int PrintTheFirstKTvariants=0;




#define _rotl(x,r) ((x << r) | (x >> (64 - r)))
#define PRIMExx 11400714819323198393ULL
void XXH_256(const void* input, size_t len, uint64_t* out)
{
    const uint8_t* p = (uint8_t*)input;
    const uint8_t* const bEnd = p + len;
    uint64_t v1 = len * PRIMExx;
    uint64_t v2 = v1;
    uint64_t v3 = v1;
    uint64_t v4 = v1;

    const size_t big_loop_step = 4 * 4 * sizeof(uint64_t);
    const size_t small_loop_step = 4 * sizeof(uint64_t);
    // Set the big loop limit early enough, so the well-mixing small loop can be executed twice after it
    const uint8_t* const big_loop_limit   = bEnd - big_loop_step - 2 * small_loop_step;
    const uint8_t* const small_loop_limit = bEnd - small_loop_step;

    while (p < big_loop_limit)
    {
        v1 = _rotl(v1, 29) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v2 = _rotl(v2, 31) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v3 = _rotl(v3, 33) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v4 = _rotl(v4, 35) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v1 += v2 *= PRIMExx;
        v1 = _rotl(v1, 29) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v2 = _rotl(v2, 31) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v3 = _rotl(v3, 33) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v4 = _rotl(v4, 35) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v2 += v3 *= PRIMExx;
        v1 = _rotl(v1, 29) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v2 = _rotl(v2, 31) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v3 = _rotl(v3, 33) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v4 = _rotl(v4, 35) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v3 += v4 *= PRIMExx;
        v1 = _rotl(v1, 29) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v2 = _rotl(v2, 31) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v3 = _rotl(v3, 33) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v4 = _rotl(v4, 35) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v4 += v1 *= PRIMExx;
    }

    while (p < small_loop_limit)
    {
        v1 = _rotl(v1, 29) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v2 += v1 *= PRIMExx;
        v2 = _rotl(v2, 31) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v3 += v2 *= PRIMExx;
        v3 = _rotl(v3, 33) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v4 += v3 *= PRIMExx;
        v4 = _rotl(v4, 35) + (*(uint64_t*)p); p+=sizeof(uint64_t);
        v1 += v4 *= PRIMExx;
    }
    memcpy(out, p, bEnd - p);

    out[0] += v1;
    out[1] += v2;
    out[2] += v3;
    out[3] += v4;
}







// farolito: [Spanish, paper lantern, diminutive of farol, lantern, from faro, lighthouse, lantern, from Latin pharus, from Pharus Pharos.]
// Stride 32 = 4x(4+4), HalfStride = (4*sizeof(uint32_t))
// Stride 8 = 4x2, HalfStride = (2*sizeof(uint16_t))
// Need for that 4th ALU ... needs HASWELL, my expectations are that FNV1A_farolito will shine on HASWELL!
// On my Core 2 T7500 2200MHz:
// Fetching/Hashing a 256bytes block 256*1024*1024 times ...
// BURST_Read_4DWORDS:         (256bytes block); 65536MB fetched in 8752 clocks or  7.488MB per clock
// BURST_Read_8DWORDSi:        (256bytes block); 65536MB fetched in 10155 clocks or 6.454MB per clock
// FNV1A_YoshimitsuTRIAD:      (256bytes block); 65536MB hashed in 10733 clocks or  6.106MB per clock
// FNV1A_YoshimitsuTRIADii:    (256bytes block); 65536MB hashed in 11902 clocks or  5.506MB per clock
// FNV1A_YoshimitsuTRIADiiXMM: (256bytes block); 65536MB hashed in 11918 clocks or  5.499MB per clock
// FNV1A_Yorikke:              (256bytes block); 65536MB hashed in 12792 clocks or  5.123MB per clock
// FNV1A_farolito:             (256bytes block); 65536MB hashed in 12870 clocks or  5.092MB per clock !!! bitter-a-bit-sweet !!!
// FNV1A_penumbra:             (256bytes block); 65536MB hashed in 12901 clocks or  5.080MB per clock
// FNV1A_Yoshimura:            (256bytes block); 65536MB hashed in 13307 clocks or  4.925MB per clock
// CRC32 0x8F6E37A0, iSCSI:    (256bytes block); 65536MB hashed in 70418 clocks or  0.931MB per clock
// On Core i3 2310M (Sandy Bridge) 2095MHz:
// Fetching/Hashing a 256bytes block 256*1024*1024 times ...
// BURST_Read_8DWORDSi:        (256bytes block); 65536MB fetched in 6735 clocks or 9.731MB per clock
// BURST_Read_4DWORDS:         (256bytes block); 65536MB fetched in 6937 clocks or 9.447MB per clock
// FNV1A_YoshimitsuTRIADiiXMM: (256bytes block); 65536MB hashed in 8719 clocks or  7.516MB per clock
// FNV1A_penumbra:             (256bytes block); 65536MB hashed in 8875 clocks or  7.384MB per clock
// FNV1A_YoshimitsuTRIAD:      (256bytes block); 65536MB hashed in 12187 clocks or 5.378MB per clock
// FNV1A_Yoshimura:            (256bytes block); 65536MB hashed in 12469 clocks or 5.256MB per clock
// FNV1A_Yorikke:              (256bytes block); 65536MB hashed in 13015 clocks or 5.035MB per clock
// FNV1A_YoshimitsuTRIADii:    (256bytes block); 65536MB hashed in 13094 clocks or 5.005MB per clock
// FNV1A_farolito:             (256bytes block); 65536MB hashed in 14063 clocks or 4.660MB per clock !!! carambaL/carambOUS !!!
// CRC32 0x8F6E37A0, iSCSI:    (256bytes block); 65536MB hashed in 78406 clocks or 0.836MB per clock
uint32_t FNV1A_farolito(const char *str, uint32_t wrdlen)
{
	const uint32_t PRIME = 591798841;
	uint32_t hash32 = 2166136261;
	uint32_t hash32B = 2166136261;
	uint32_t hash32C = 2166136261;
	uint32_t hash32D = 2166136261;
	const char *p = str;
	uint32_t Loop_Counter;
	uint32_t Second_Line_Offset;
if (wrdlen >= 2*(4*sizeof(uint32_t))) {
	Loop_Counter = (wrdlen>>5);
	Loop_Counter++;
	Second_Line_Offset = wrdlen-(Loop_Counter)*((4*sizeof(uint32_t)));
	for(; Loop_Counter; Loop_Counter--, p += (4*sizeof(uint32_t))) {
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),27) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset),27) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8),27) ^ *(uint32_t *)(p+8+Second_Line_Offset))) * PRIME;        
		hash32D = (hash32D ^ (_rotl_KAZE(*(uint32_t *)(p+12+Second_Line_Offset),27) ^ *(uint32_t *)(p+12))) * PRIME;        
	}
	hash32 = _rotl_KAZE((hash32 ^ _rotl_KAZE(hash32B,16)) * PRIME,24);
	hash32 = _rotl_KAZE((hash32 ^ _rotl_KAZE(hash32C,16)) * PRIME,16);
	hash32 = _rotl_KAZE((hash32 ^ _rotl_KAZE(hash32D,16)) * PRIME,8);
} else if (wrdlen >= 2*(2*sizeof(uint16_t))) {
	Loop_Counter = (wrdlen>>2);
	Loop_Counter++;
	Second_Line_Offset = wrdlen-(Loop_Counter)*((2*sizeof(uint16_t)));
	for(; Loop_Counter; Loop_Counter--, p += (2*sizeof(uint16_t))) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+0+Second_Line_Offset)) * PRIME;
		hash32C= (hash32C ^ *(uint16_t*)(p+0+2)) * PRIME;
		hash32D = (hash32D ^ *(uint16_t*)(p+0+Second_Line_Offset+2)) * PRIME;
	}
	hash32 = _rotl_KAZE((hash32 ^ _rotl_KAZE(hash32B,16)) * PRIME,24);
	hash32 = _rotl_KAZE((hash32 ^ _rotl_KAZE(hash32C,16)) * PRIME,16);
	hash32 = _rotl_KAZE((hash32 ^ _rotl_KAZE(hash32D,16)) * PRIME,8);
} else {
	// Cases: 0,1,2,3,4,5,6,7:
	if (wrdlen & 2*sizeof(uint16_t)) {
		hash32 = (hash32 ^ *(p+0)) * PRIME;
		hash32 = (hash32 ^ *(p+1)) * PRIME;
		hash32 = (hash32 ^ *(p+2)) * PRIME;
		hash32 = (hash32 ^ *(p+3)) * PRIME;
		p += 2*sizeof(uint16_t);
	}
	if (wrdlen & sizeof(uint16_t)) {
		hash32 = (hash32 ^ *(p+0)) * PRIME;
		hash32 = (hash32 ^ *(p+1)) * PRIME;
		p += sizeof(uint16_t);
	}
	if (wrdlen & 1) {
		hash32 = (hash32 ^ *(p+0)) * PRIME;
	}
}
	return hash32 ^ (hash32 >> 16);
}
// FNV1A_farolito's 32[+] main loop, 045ac-04560+2 = 78bytes:
/*
  04553 8d b6 00 00 00 
        00 8d bc 27 00 
        00 00 00         ALIGN     16
.B9.4:
;;; 	for(; Loop_Counter; Loop_Counter--, p += (4*sizeof(uint32_t))) {
;;; 		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),27) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        

  04560 8b 08            mov ecx, DWORD PTR [eax]               
  04562 c1 c1 1b         rol ecx, 27                            
  04565 33 0c 10         xor ecx, DWORD PTR [eax+edx]           
  04568 33 e9            xor ebp, ecx                           

;;; 		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset),27) ^ *(uint32_t *)(p+4))) * PRIME;        

  0456a 8b 4c 10 04      mov ecx, DWORD PTR [4+eax+edx]         
  0456e c1 c1 1b         rol ecx, 27                            
  04571 33 48 04         xor ecx, DWORD PTR [4+eax]             
  04574 33 d9            xor ebx, ecx                           

;;; 		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8),27) ^ *(uint32_t *)(p+8+Second_Line_Offset))) * PRIME;        

  04576 8b 48 08         mov ecx, DWORD PTR [8+eax]             
  04579 c1 c1 1b         rol ecx, 27                            
  0457c 33 4c 10 08      xor ecx, DWORD PTR [8+eax+edx]         
  04580 33 f1            xor esi, ecx                           

;;; 		hash32D = (hash32D ^ (_rotl_KAZE(*(uint32_t *)(p+12+Second_Line_Offset),27) ^ *(uint32_t *)(p+12))) * PRIME;        

  04582 8b 4c 10 0c      mov ecx, DWORD PTR [12+eax+edx]        
  04586 c1 c1 1b         rol ecx, 27                            
  04589 33 48 0c         xor ecx, DWORD PTR [12+eax]            
  0458c 83 c0 10         add eax, 16                            
  0458f 33 f9            xor edi, ecx                           
  04591 69 ed 39 22 46 
        23               imul ebp, ebp, 591798841               
  04597 69 db 39 22 46 
        23               imul ebx, ebx, 591798841               
  0459d 69 f6 39 22 46 
        23               imul esi, esi, 591798841               
  045a3 69 ff 39 22 46 
        23               imul edi, edi, 591798841               
  045a9 ff 0c 24         dec DWORD PTR [esp]                    
  045ac 75 b2            jne .B9.4
*/
// FNV1A_farolito's 8[+] main loop, 0194b-01918+2 = 53bytes:
/*
.B4.2:
;;; 	for(; Loop_Counter; Loop_Counter--, p += (2*sizeof(uint16_t))) {
;;; 		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;

  01918 0f b7 2a         movzx ebp, WORD PTR [edx]              
  0191b 33 cd            xor ecx, ebp                           

;;; 		hash32B = (hash32B ^ *(uint16_t*)(p+0+Second_Line_Offset)) * PRIME;

  0191d 0f b7 6a fc      movzx ebp, WORD PTR [-4+edx]           
  01921 33 fd            xor edi, ebp                           

;;; 		hash32C= (hash32C ^ *(uint16_t*)(p+0+2)) * PRIME;

  01923 0f b7 6a 02      movzx ebp, WORD PTR [2+edx]            
  01927 33 f5            xor esi, ebp                           

;;; 		hash32D = (hash32D ^ *(uint16_t*)(p+0+Second_Line_Offset+2)) * PRIME;

  01929 0f b7 6a fe      movzx ebp, WORD PTR [-2+edx]           
  0192d 33 dd            xor ebx, ebp                           
  0192f 69 c9 39 22 46 
        23               imul ecx, ecx, 591798841               
  01935 83 c2 04         add edx, 4                             
  01938 69 ff 39 22 46 
        23               imul edi, edi, 591798841               
  0193e 69 f6 39 22 46 
        23               imul esi, esi, 591798841               
  01944 69 db 39 22 46 
        23               imul ebx, ebx, 591798841               
  0194a 48               dec eax                                
  0194b 75 cb            jne .B4.2
.B4.3:
;;; 	}
*/



// FNV1A_marline aka FNV1A_YoshimitsuTRIADii revision 2, copyleft 2013-Jul-09, Kaze.
// marline: A light rope made of two loosely twisted strands.
// [Middle English, from Middle Dutch marlijn, alteration (influenced by lijn, line), of marling from marren, to tie.]
#define ROLInBits 27 // 5 in r.1; Caramba: it should be ROR by 5 not ROL, from the very beginning the idea was to mix two bytes by shifting/masking the first 5 'noisy' bits (ASCII 0-31 symbols).
uint32_t FNV1A_marline(const char *str, uint32_t wrdlen)
{
    // r2:
    const uint32_t PRIME = 591798841;

    // 709607:
    // D:\_KAZE\YoYo_r2>YoYo_r2.exe 4andabove_Gamera17LBL.2.txt.sorted 25
    // FNV1A_YoshimitsuTRIADii    : Keys = 00,000,000,000,037,030,186; 000,000,006 x MAXcollisionsAtSomeSlots = 0,000,000,010; HASHfreeSLOTS = 0,011,133,920;
    // CRC32 0x8F6E37A0           : Keys = 00,000,000,000,037,030,186; 000,000,001 x MAXcollisionsAtSomeSlots = 0,000,000,011; HASHfreeSLOTS = 0,011,127,363;
    // D:\_KAZE\YoYo_r2>YoYo_r2.exe 4andabove_Gamera17LBL.2.txt.sorted 26
    // FNV1A_YoshimitsuTRIADii    : Keys = 00,000,000,000,037,030,186; 000,000,002 x MAXcollisionsAtSomeSlots = 0,000,000,009; HASHfreeSLOTS = 0,038,654,435;
    // CRC32 0x8F6E37A0           : Keys = 00,000,000,000,037,030,186; 000,000,001 x MAXcollisionsAtSomeSlots = 0,000,000,009; HASHfreeSLOTS = 0,038,648,206;

    // 591798841:
    // D:\_KAZE\YoYo_r2>YoYo_r2.exe 4andabove_Gamera17LBL.2.txt.sorted 25
    // FNV1A_YoshimitsuTRIADii    : Keys = 00,000,000,000,037,030,186; 000,000,003 x MAXcollisionsAtSomeSlots = 0,000,000,011; HASHfreeSLOTS = 0,011,124,498;
    // CRC32 0x8F6E37A0           : Keys = 00,000,000,000,037,030,186; 000,000,001 x MAXcollisionsAtSomeSlots = 0,000,000,011; HASHfreeSLOTS = 0,011,127,363;
    // D:\_KAZE\YoYo_r2>YoYo_r2.exe 4andabove_Gamera17LBL.2.txt.sorted 26
    // FNV1A_YoshimitsuTRIADii    : Keys = 00,000,000,000,037,030,186; 000,000,003 x MAXcollisionsAtSomeSlots = 0,000,000,009; HASHfreeSLOTS = 0,038,646,657;
    // CRC32 0x8F6E37A0           : Keys = 00,000,000,000,037,030,186; 000,000,001 x MAXcollisionsAtSomeSlots = 0,000,000,009; HASHfreeSLOTS = 0,038,648,206;

    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    const char *p = str;
    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

if (wrdlen >= 24) {
    Loop_Counter = (wrdlen/24);
    Loop_Counter++;
    //if (wrdlen >= 128 && Loop_Counter%4) Loop_Counter += 4-(Loop_Counter%4); // x01+3, x10+2, x11+1
    if (wrdlen >= 128 && (Loop_Counter&3)) Loop_Counter += 4-(Loop_Counter&3); // x01+3, x10+2, x11+1
    Second_Line_Offset = wrdlen-(Loop_Counter)*(3*4); // GRMBL: when (p%16==0 && wrdlen%16==0) && (Loop_Counter%4!=0) Second_Line_Offset could be misaligned since 12 lacks 16/48/96/192 divisibility, could be aligned by prefixing 3[-] 3*4 pairs i.e. adding 36|24|12 bytes.
    // When wrdlen is 128:
    // Loop_Counter: 5+1+2=8
    // Second_Line_Offset: 128-(5+1+2)*(3*4)=32
    for(; Loop_Counter; Loop_Counter--, p += 3*sizeof(uint32_t)) {
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),ROLInBits) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset),ROLInBits) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8),ROLInBits) ^ *(uint32_t *)(p+8+Second_Line_Offset))) * PRIME;        
    }
		hash32 = (hash32 ^ _rotl_KAZE(hash32C,ROLInBits) ) * PRIME;
} else {
    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		//hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),ROLInBits) ^ *(uint32_t *)(p+4))) * PRIME;        
		//hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),ROLInBits) ^ *(uint32_t *)(p+12))) * PRIME;        
		// r2:
		hash32 = (hash32 ^ (*(uint32_t *)(p+0))) * PRIME;        
		hash32B = (hash32B ^ (*(uint32_t *)(p+8))) * PRIME;        
		hash32 = (hash32 ^ (*(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (*(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;
}
    hash32 = (hash32 ^ _rotl_KAZE(hash32B,ROLInBits) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}









// "There it now stands for ever. Black on white.
// I can't get away from it. Ahoy, Yorikke, ahoy, hoy, ho!
// Go to hell now if you wish. What do I care? It's all the same now to me.
// I am part of you now. Where you go I go, where you leave I leave, when you go to the devil I go. Married.
// Vanished from the living. Damned and doomed. Of me there is not left a breath in all the vast world.
// Ahoy, Yorikke! Ahoy, hoy, ho!
// I am not buried in the sea,
// The death ship is now part of me
// So far from sunny New Orleans
// So far from lovely Louisiana."
// /An excerpt from 'THE DEATH SHIP - THE STORY OF AN AMERICAN SAILOR' by B.TRAVEN/
// 
// "Walking home to our good old Yorikke, I could not help thinking of this beautiful ship, with a crew on board that had faces as if they were seeing ghosts by day and by night.
// Compared to that gilded Empress, the Yorikke was an honorable old lady with lavender sachets in her drawers.
// Yorikke did not pretend to anything she was not. She lived up to her looks. Honest to her lowest ribs and to the leaks in her bilge.
// Now, what is this? I find myself falling in love with that old jane.
// All right, I cannot pass by you, Yorikke; I have to tell you I love you. Honest, baby, I love you.
// I have six black finger-nails, and four black and green-blue nails on my toes, which you, honey, gave me when necking you.
// Grate-bars have crushed some of my toes. And each finger-nail has its own painful story to tell.
// My chest, my back, my arms, my legs are covered with scars of burns and scorchings.
// Each scar, when it was being created, caused me pains which I shall surely never forget.
// But every outcry of pain was a love-cry for you, honey.
// You are no hypocrite. Your heart does not bleed tears when you do not feel heart-aches deeply and truly.
// You do not dance on the water if you do not feel like being jolly and kicking chasers in the pants.
// Your heart never lies. It is fine and clean like polished gold. Never mind the rags, honey dear.
// When you laugh, your whole soul and all your body is laughing.
// And when you weep, sweety, then you weep so that even the reefs you pass feel like weeping with you.
// I never want to leave you again, honey. I mean it. Not for all the rich and elegant buckets in the world.
// I love you, my gypsy of the sea!"
// /An excerpt from 'THE DEATH SHIP - THE STORY OF AN AMERICAN SAILOR' by B.TRAVEN/
uint32_t FNV1A_Hash_Yorikke(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    const char *p = str;

    for(; wrdlen >= 2*2*sizeof(uint32_t); wrdlen -= 2*2*sizeof(uint32_t), p += 2*2*sizeof(uint32_t)) {
        hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
        hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
    }

    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;

    hash32 = (hash32 ^ _rotl_KAZE(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}

uint32_t FNV1A_Hash_Yoshimura(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    const char *p = str;
    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

if (wrdlen >= 2*2*sizeof(uint32_t)) {
    Second_Line_Offset = wrdlen-((wrdlen>>4)+1)*(2*4); // ((wrdlen>>1)>>3)
    Loop_Counter = (wrdlen>>4);
    //if (wrdlen%16) Loop_Counter++;
    Loop_Counter++;
    for(; Loop_Counter; Loop_Counter--, p += 2*sizeof(uint32_t)) {
		// revision 1:
		//hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		//hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+0+Second_Line_Offset),5) ^ *(uint32_t *)(p+4+Second_Line_Offset))) * PRIME;        
		// revision 2:
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset),5) ^ *(uint32_t *)(p+4))) * PRIME;        
    }
} else {
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;
}
    hash32 = (hash32 ^ _rotl_KAZE(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}

uint32_t BURST_Read_4DWORDS(const char *str, uint32_t wrdlen)
{
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    uint32_t hash32D = 2166136261;
    const char *p = str;

    for(; wrdlen >= 2*2*sizeof(uint32_t); wrdlen -= 2*2*sizeof(uint32_t), p += 2*2*sizeof(uint32_t)) {
        hash32 = *(uint32_t *)(p+0);
        hash32B = *(uint32_t *)(p+4);
        hash32C = *(uint32_t *)(p+8);
        hash32D = *(uint32_t *)(p+12);
    }

    return hash32 ^ hash32B ^ hash32C ^ hash32D;
}

uint32_t BURST_Read_8DWORDSi(const char *str, uint32_t wrdlen)
{
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    uint32_t hash32D = 2166136261;
    const char *p = str;

    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

    Loop_Counter = (wrdlen/32);
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(4*4);
    for(; Loop_Counter; Loop_Counter--, p += 4*sizeof(uint32_t)) {
        hash32 = *(uint32_t *)(p+0) ^ *(uint32_t *)(p+0+Second_Line_Offset);
        hash32B = *(uint32_t *)(p+4) ^ *(uint32_t *)(p+4+Second_Line_Offset);
        hash32C = *(uint32_t *)(p+8) ^ *(uint32_t *)(p+8+Second_Line_Offset);
        hash32D = *(uint32_t *)(p+12) ^ *(uint32_t *)(p+12+Second_Line_Offset);
    }

    return hash32 ^ hash32B ^ hash32C ^ hash32D;
}

uint32_t BURST_Read_3DWORDS(const char *str, uint32_t wrdlen)
{
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    const char *p = str;

    for(; wrdlen >= 3*sizeof(uint32_t); wrdlen -= 3*sizeof(uint32_t), p += 3*sizeof(uint32_t)) {
        hash32 = *(uint32_t *)(p+0);
        hash32B = *(uint32_t *)(p+4);
        hash32C = *(uint32_t *)(p+8);
    }

    return hash32 ^ hash32B ^ hash32C;
}

uint32_t BURST_Read_6DWORDSi(const char *str, uint32_t wrdlen)
{
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    uint32_t hash32interleaved = 2166136261;
    uint32_t hash32Binterleaved = 2166136261;
    uint32_t hash32Cinterleaved = 2166136261;
    const char *p = str;

    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

    Loop_Counter = (wrdlen/24);
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(3*4);
    for(; Loop_Counter; Loop_Counter--, p += 3*sizeof(uint32_t)) {
        hash32 = *(uint32_t *)(p+0);
        hash32interleaved = *(uint32_t *)(p+0+Second_Line_Offset);
        hash32B = *(uint32_t *)(p+4);
        hash32Binterleaved = *(uint32_t *)(p+4+Second_Line_Offset);
        hash32C = *(uint32_t *)(p+8);
        hash32Cinterleaved = *(uint32_t *)(p+8+Second_Line_Offset);
    }

    return hash32 ^ hash32B ^ hash32C ^ hash32interleaved ^ hash32Binterleaved ^ hash32Cinterleaved;
}


//#define XMM_KAZE
#define XMM_INSANE
#define xmmload(p) _mm_load_si128((__m128i const*)(p))
#define xmmloadu(p) _mm_loadu_si128((__m128i const*)(p))
//
//extern int   __ICL_INTRINCC _mm_extract_epi32(__m128i, const int);
//#if defined(__x86_64) || defined(_M_X64)
//extern __int64 __ICL_INTRINCC _mm_extract_epi64(__m128i, const int);
//
/****************************************************/
/*  NAME : mm_prefetch                              */
/*  DESCRIPTION : prefetch                          */
/*  IN : float *a : address to prefetch             */
/*  OUT : none                                      */
/*  RETURN : none                                   */
/****************************************************/
//_MM_INLINE_COMMAND static void __cdecl _mm_prefetch(char const *a, int sel)
//{
//  /* second param not used */
//  volatile char pp = *a;
//}
/****************************************************/
/*  NAME : mm_storel_pi                             */
/*  DESCRIPTION : Move lower 64 bits of a m128 reg  */
/*                to memory                         */
/*  IN : m128 b : 128 bit register source           */
/*  OUT : m64 *a : 64 bit register destination      */
/*  RETURN : none                                   */
/****************************************************/
//_MM_INLINE_COMMAND static void __cdecl _mm_storel_pi(__m64 *a, __m128 b)
//{
//  _mm_m128 bb;
//
//  bb.m128.m = b;
//  ((int*)a)[0] = bb.m128.dw[0];
//  ((int*)a)[1] = bb.m128.dw[1];
//}
/****************************************************/
/*  NAME : mm_storeu_ps                              */
/*  DESCRIPTION : packed single store               */
/*  IN : m128 a : m128 to load from                 */
/*  OUT : float *v : (fp0(a),fp1(a),fp2(a),fp3(a))  */
/*  RETURN : none                                   */
/*  NOTE : 4 floats will be return. it is up to the */
/*         caller to ensure space is available      */
/****************************************************/
//_MM_INLINE_COMMAND static void __cdecl _mm_storeu_ps(float *v, __m128 a)
//{
//  v[0] = _MM_FP0(a);
//  v[1] = _MM_FP1(a);
//  v[2] = _MM_FP2(a);
//  v[3] = _MM_FP3(a);
//}
/****************************************************/
/*  NAME : mm_xor_ps                                */
/*  DESCRIPTION : bitwise logical XOR on single FP  */
/*  IN : m128 a : operand 1                         */
/*       m128 b : operand 2                         */
/*  OUT : none                                      */
/*  RETURN : m128 : a XOR b                         */
/****************************************************/
//_MM_INLINE_COMMAND static __m128 __cdecl _mm_xor_ps(__m128 a, __m128 b)
//{
//  __m128 ret;
//
//  _MM_INT0(ret) = _MM_INT0(a) ^ _MM_INT0(b);
//  _MM_INT1(ret) = _MM_INT1(a) ^ _MM_INT1(b);
//  _MM_INT2(ret) = _MM_INT2(a) ^ _MM_INT2(b);
//  _MM_INT3(ret) = _MM_INT3(a) ^ _MM_INT3(b);
//
//  return ret;
//}
//
uint32_t FNV1A_Hash_YoshimitsuTRIADiiXMMr1(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    const char *p = str;
    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

#if defined(XMM_KAZE) || defined(XMM_INSANE)
    __m128i xmm0;
    __m128i xmm1;
    __m128i xmm2;
    __m128i xmm3;
    __m128i xmm4;
    __m128i xmm5;
    __m128i hash32xmm = _mm_set1_epi32(2166136261);
    __m128i hash32Bxmm = _mm_set1_epi32(2166136261);
    __m128i hash32Cxmm = _mm_set1_epi32(2166136261);
    __m128i PRIMExmm = _mm_set1_epi32(709607);
#endif

if (wrdlen >= 4*24) {
    Loop_Counter = (wrdlen/(4*24));
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(4*3*4);
    for(; Loop_Counter; Loop_Counter--, p += 4*3*sizeof(uint32_t)) {
#if defined(XMM_KAZE) || defined(XMM_INSANE)
#if defined(XMM_KAZE)
	xmm0 = xmmloadu(p+0*16);
	xmm1 = xmmloadu(p+0*16+Second_Line_Offset);
	xmm2 = xmmloadu(p+1*16);
	xmm3 = xmmloadu(p+1*16+Second_Line_Offset);
	xmm4 = xmmloadu(p+2*16);
	xmm5 = xmmloadu(p+2*16+Second_Line_Offset);
// This atrocity should be done in XMM assembler not C, with only 128bitregister-to-64bitregister extracts of course [
    // FL: 00 maps onto _MM_INT0(xmm0) | SL: 00 maps onto _MM_INT0(xmm1)
    // FL: 04 maps onto _MM_INT1(xmm0) | SL: 04 maps onto _MM_INT1(xmm1)
    // FL: 08 maps onto _MM_INT2(xmm0) | SL: 08 maps onto _MM_INT2(xmm1)
    // FL: 12 maps onto _MM_INT3(xmm0) | SL: 12 maps onto _MM_INT3(xmm1)
    // FL: 16 maps onto _MM_INT0(xmm2) | SL: 16 maps onto _MM_INT0(xmm3)
    // FL: 20 maps onto _MM_INT1(xmm2) | SL: 20 maps onto _MM_INT1(xmm3)
    // FL: 24 maps onto _MM_INT2(xmm2) | SL: 24 maps onto _MM_INT2(xmm3)
    // FL: 28 maps onto _MM_INT3(xmm2) | SL: 28 maps onto _MM_INT3(xmm3)
    // FL: 32 maps onto _MM_INT0(xmm4) | SL: 32 maps onto _MM_INT0(xmm5)
    // FL: 36 maps onto _MM_INT1(xmm4) | SL: 36 maps onto _MM_INT1(xmm5)
    // FL: 40 maps onto _MM_INT2(xmm4) | SL: 40 maps onto _MM_INT2(xmm5)
    // FL: 44 maps onto _MM_INT3(xmm4) | SL: 44 maps onto _MM_INT3(xmm5)
    // FL: 00 xmm0.m128i_u32[0]        SL: 00 xmm1.m128i_u32[0]
    // SL: 04 xmm1.m128i_u32[1]        FL: 04 xmm0.m128i_u32[1]
    // FL: 08 xmm0.m128i_u32[2]        SL: 08 xmm1.m128i_u32[2]
		hash32 = (hash32 ^ (_rotl_KAZE(xmm0.m128i_u32[0],5) ^ xmm1.m128i_u32[0])) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(xmm1.m128i_u32[1],5) ^ xmm0.m128i_u32[1])) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(xmm0.m128i_u32[2],5) ^ xmm1.m128i_u32[2])) * PRIME;      
    // FL: 12 xmm0.m128i_u32[3]        SL: 12 xmm1.m128i_u32[3]
    // SL: 16 xmm3.m128i_u32[0]        FL: 16 xmm2.m128i_u32[0]
    // FL: 20 xmm2.m128i_u32[1]        SL: 20 xmm3.m128i_u32[1]
		hash32 = (hash32 ^ (_rotl_KAZE(xmm0.m128i_u32[3],5) ^ xmm1.m128i_u32[3])) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(xmm3.m128i_u32[0],5) ^ xmm2.m128i_u32[0])) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(xmm2.m128i_u32[1],5) ^ xmm3.m128i_u32[1])) * PRIME;        
    // FL: 24         SL: 24
    // SL: 28         FL: 28
    // FL: 32         SL: 32
		hash32 = (hash32 ^ (_rotl_KAZE(xmm2.m128i_u32[2],5) ^ xmm3.m128i_u32[2])) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(xmm3.m128i_u32[3],5) ^ xmm2.m128i_u32[3])) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(xmm4.m128i_u32[0],5) ^ xmm5.m128i_u32[0])) * PRIME;        
    // FL: 36         SL: 36
    // SL: 40         FL: 40
    // FL: 44         SL: 44
		hash32 = (hash32 ^ (_rotl_KAZE(xmm4.m128i_u32[1],5) ^ xmm5.m128i_u32[1])) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(xmm5.m128i_u32[2],5) ^ xmm4.m128i_u32[2])) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(xmm4.m128i_u32[3],5) ^ xmm5.m128i_u32[3])) * PRIME;        
// This atrocity should be done in XMM assembler not C, with only 128bitregister-to-64bitregister extracts of course ]
#else
//printf("%p\n",p);
	xmm0 = xmmloadu(p+0*16);
	xmm1 = xmmloadu(p+0*16+Second_Line_Offset);
	xmm2 = xmmloadu(p+1*16);
	xmm3 = xmmloadu(p+1*16+Second_Line_Offset);
	xmm4 = xmmloadu(p+2*16);
	xmm5 = xmmloadu(p+2*16+Second_Line_Offset);
		//hash32xmm = _mm_mul_epu32(_mm_xor_si128(hash32xmm , (_mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1))) , PRIMExmm);       
		//hash32Bxmm = _mm_mul_epu32(_mm_xor_si128(hash32Bxmm , (_mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2))) , PRIMExmm);        
		//hash32Cxmm = _mm_mul_epu32(_mm_xor_si128(hash32Cxmm , (_mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5))) , PRIMExmm);      
		//??? crashes ???: My CPU T7500 supports up to SSSE3 but not 4.1:
		hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , (_mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1))) , PRIMExmm);       
		hash32Bxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Bxmm , (_mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2))) , PRIMExmm);        
		hash32Cxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Cxmm , (_mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5))) , PRIMExmm);      

#endif
#else
    // FL: 00         SL: 00
    // SL: 04         FL: 04
    // FL: 08         SL: 08
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0+0*12),5) ^ *(uint32_t *)(p+0+Second_Line_Offset+0*12))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset+0*12),5) ^ *(uint32_t *)(p+4+0*12))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8+0*12),5) ^ *(uint32_t *)(p+8+Second_Line_Offset+0*12))) * PRIME;      
    // FL: 12         SL: 12
    // SL: 16         FL: 16
    // FL: 20         SL: 20
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0+1*12),5) ^ *(uint32_t *)(p+0+Second_Line_Offset+1*12))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset+1*12),5) ^ *(uint32_t *)(p+4+1*12))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8+1*12),5) ^ *(uint32_t *)(p+8+Second_Line_Offset+1*12))) * PRIME;        
    // FL: 24         SL: 24
    // SL: 28         FL: 28
    // FL: 32         SL: 32
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0+2*12),5) ^ *(uint32_t *)(p+0+Second_Line_Offset+2*12))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset+2*12),5) ^ *(uint32_t *)(p+4+2*12))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8+2*12),5) ^ *(uint32_t *)(p+8+Second_Line_Offset+2*12))) * PRIME;        
    // FL: 36         SL: 36
    // SL: 40         FL: 40
    // FL: 44         SL: 44
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0+3*12),5) ^ *(uint32_t *)(p+0+Second_Line_Offset+3*12))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset+3*12),5) ^ *(uint32_t *)(p+4+3*12))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8+3*12),5) ^ *(uint32_t *)(p+8+Second_Line_Offset+3*12))) * PRIME;        
#endif
    }
#if defined(XMM_INSANE)


// emmintrin.h
// Principal header file for Intel(R) Pentium(R) 4 processor SSE2 intrinsics
//extern __m128i __ICL_INTRINCC _mm_mulhi_epi16(__m128i, __m128i);
//extern __m128i __ICL_INTRINCC _mm_mulhi_epu16(__m128i, __m128i);
//extern __m128i __ICL_INTRINCC _mm_mullo_epi16(__m128i, __m128i);
//extern __m128i __ICL_INTRINCC _mm_mul_epu32(__m128i, __m128i);

// smmintrin.h
// SSE4.1 intrinsics
// Packed integer 32-bit multiplication with truncation of upper halves of results
//extern __m128i __ICL_INTRINCC _mm_mullo_epi32(__m128i, __m128i);
// Packed integer 32-bit multiplication of 2 pairs of operands producing two 64-bit results
//extern __m128i __ICL_INTRINCC _mm_mul_epi32(__m128i, __m128i);

// immintrin.h
// Intel(R) AVX compiler intrinsics.
//extern __m256i __cdecl _mm256_mullo_epi32(__m256i, __m256i);
//extern __m256i __cdecl _mm256_mul_epu32(__m256i, __m256i);
//extern __m256i __cdecl _mm256_mul_epi32(__m256i, __m256i);
//...
//    __int8              m256i_i8[32];
//    __int16             m256i_i16[16];
//    __int32             m256i_i32[8];
//    __int64             m256i_i64[4];
//    unsigned __int8     m256i_u8[32];
//    unsigned __int16    m256i_u16[16];
//    unsigned __int32    m256i_u32[8];
//    unsigned __int64    m256i_u64[4];
//} __m256i;
//
// Move Aligned Packed Integer Values
// **** VMOVDQA ymm1, m256
// **** VMOVDQA m256, ymm1
// Moves 256 bits of packed integer values from the source operand to the destination
//extern __m256i __ICL_INTRINCC _mm256_load_si256(__m256i const *);
//extern void    __ICL_INTRINCC _mm256_store_si256(__m256i *, __m256i);
//
// Move Unaligned Packed Integer Values
// **** VMOVDQU ymm1, m256
// **** VMOVDQU m256, ymm1
// Moves 256 bits of packed integer values from the source operand to the destination
//extern __m256i __ICL_INTRINCC _mm256_loadu_si256(__m256i const *);
//extern void    __ICL_INTRINCC _mm256_storeu_si256(__m256i *, __m256i);


/*
hash32xmm = _mm_set1_epi32(1);
printf("%lu,%lu,%lu,%lu\n",PRIMExmm.m128i_u32[0],PRIMExmm.m128i_u32[1],PRIMExmm.m128i_u32[2],PRIMExmm.m128i_u32[3]);
printf("%lu,%lu,%lu,%lu\n",hash32xmm.m128i_u32[0],hash32xmm.m128i_u32[1],hash32xmm.m128i_u32[2],hash32xmm.m128i_u32[3]);
hash32Bxmm = _mm_mul_epu32( hash32xmm, PRIMExmm);       
printf("%lu,%lu,%lu,%lu\n",hash32Bxmm.m128i_u32[0],hash32Bxmm.m128i_u32[1],hash32Bxmm.m128i_u32[2],hash32Bxmm.m128i_u32[3]);
hash32Bxmm = _mm_mullo_epi16( hash32xmm, PRIMExmm);       
printf("%lu,%lu,%lu,%lu\n",hash32Bxmm.m128i_u32[0],hash32Bxmm.m128i_u32[1],hash32Bxmm.m128i_u32[2],hash32Bxmm.m128i_u32[3]);
// 709607,709607,709607,709607
// 1,1,1,1
// 709607,0,709607,0
// 54247,54247,54247,54247
hash32xmm = _mm_set1_epi32(3);
printf("%lu,%lu,%lu,%lu\n",PRIMExmm.m128i_u32[0],PRIMExmm.m128i_u32[1],PRIMExmm.m128i_u32[2],PRIMExmm.m128i_u32[3]);
printf("%lu,%lu,%lu,%lu\n",hash32xmm.m128i_u32[0],hash32xmm.m128i_u32[1],hash32xmm.m128i_u32[2],hash32xmm.m128i_u32[3]);
hash32Bxmm = _mm_mul_epu32( hash32xmm, PRIMExmm);       
printf("%lu,%lu,%lu,%lu\n",hash32Bxmm.m128i_u32[0],hash32Bxmm.m128i_u32[1],hash32Bxmm.m128i_u32[2],hash32Bxmm.m128i_u32[3]);
hash32Bxmm = _mm_mullo_epi16( hash32xmm, PRIMExmm);       
printf("%lu,%lu,%lu,%lu\n",hash32Bxmm.m128i_u32[0],hash32Bxmm.m128i_u32[1],hash32Bxmm.m128i_u32[2],hash32Bxmm.m128i_u32[3]);
// 709607,709607,709607,709607
// 3,3,3,3
// 2128821,0,2128821,0
// 31669,31669,31669,31669
hash32xmm = _mm_set1_epi32(3000000);
printf("%lu,%lu,%lu,%lu\n",PRIMExmm.m128i_u32[0],PRIMExmm.m128i_u32[1],PRIMExmm.m128i_u32[2],PRIMExmm.m128i_u32[3]);
printf("%lu,%lu,%lu,%lu\n",hash32xmm.m128i_u32[0],hash32xmm.m128i_u32[1],hash32xmm.m128i_u32[2],hash32xmm.m128i_u32[3]);
hash32Bxmm = _mm_mul_epu32( hash32xmm, PRIMExmm);       
printf("%lu,%lu,%lu,%lu\n",hash32Bxmm.m128i_u32[0],hash32Bxmm.m128i_u32[1],hash32Bxmm.m128i_u32[2],hash32Bxmm.m128i_u32[3]);
hash32Bxmm = _mm_mullo_epi16( hash32xmm, PRIMExmm);       
printf("%lu,%lu,%lu,%lu\n",hash32Bxmm.m128i_u32[0],hash32Bxmm.m128i_u32[1],hash32Bxmm.m128i_u32[2],hash32Bxmm.m128i_u32[3]);
// 709607,709607,709607,709607
// 3000000,3000000,3000000,3000000
// 2812188480,495,2812188480,495 !!! 495 *(1<<32)+2812188480=2128821000000 = 709607*3000000 !!!
// 29529920,29529920,29529920,29529920
hash32xmm = _mm_set1_epi32(65536);
printf("%lu,%lu,%lu,%lu\n",PRIMExmm.m128i_u32[0],PRIMExmm.m128i_u32[1],PRIMExmm.m128i_u32[2],PRIMExmm.m128i_u32[3]);
printf("%lu,%lu,%lu,%lu\n",hash32xmm.m128i_u32[0],hash32xmm.m128i_u32[1],hash32xmm.m128i_u32[2],hash32xmm.m128i_u32[3]);
hash32Bxmm = _mm_mul_epu32( hash32xmm, PRIMExmm);       
printf("%lu,%lu,%lu,%lu\n",hash32Bxmm.m128i_u32[0],hash32Bxmm.m128i_u32[1],hash32Bxmm.m128i_u32[2],hash32Bxmm.m128i_u32[3]);
hash32Bxmm = _mm_mullo_epi16( hash32xmm, PRIMExmm);       
printf("%lu,%lu,%lu,%lu\n",hash32Bxmm.m128i_u32[0],hash32Bxmm.m128i_u32[1],hash32Bxmm.m128i_u32[2],hash32Bxmm.m128i_u32[3]);
// 709607,709607,709607,709607
// 65536,65536,65536,65536
// 3555131392,10,3555131392,10
// 655360,655360,655360,655360
hash32xmm = _mm_set1_epi32(65535);
printf("%lu,%lu,%lu,%lu\n",PRIMExmm.m128i_u32[0],PRIMExmm.m128i_u32[1],PRIMExmm.m128i_u32[2],PRIMExmm.m128i_u32[3]);
printf("%lu,%lu,%lu,%lu\n",hash32xmm.m128i_u32[0],hash32xmm.m128i_u32[1],hash32xmm.m128i_u32[2],hash32xmm.m128i_u32[3]);
hash32Bxmm = _mm_mul_epu32( hash32xmm, PRIMExmm);       
printf("%lu,%lu,%lu,%lu\n",hash32Bxmm.m128i_u32[0],hash32Bxmm.m128i_u32[1],hash32Bxmm.m128i_u32[2],hash32Bxmm.m128i_u32[3]);
hash32Bxmm = _mm_mullo_epi16( hash32xmm, PRIMExmm);       
printf("%lu,%lu,%lu,%lu\n",hash32Bxmm.m128i_u32[0],hash32Bxmm.m128i_u32[1],hash32Bxmm.m128i_u32[2],hash32Bxmm.m128i_u32[3]);
// 709607,709607,709607,709607
// 65535,65535,65535,65535
// 3554421785,10,3554421785,10
// 11289,11289,11289,11289
exit(1);
*/

/*
; mark_description "Intel(R) C++ Compiler XE for applications running on IA-32, Version 12.1.1.258 Build 20111011";
; mark_description "-Ox -TcHASH_linearspeed_FURY.c -FaHASH_linearspeed_FURY_Intel_IA-32_12 -FAcs";

// ==================================== [ SSE2 ] ====================================

;;; #else
;;; 
;;; 	xmm0 = xmmloadu(p+0*16);
;;; 	xmm1 = xmmloadu(p+0*16+Second_Line_Offset);
;;; 	xmm2 = xmmloadu(p+1*16);
;;; 	xmm3 = xmmloadu(p+1*16+Second_Line_Offset);

  0270b 03 d9            add ebx, ecx                           
                                ; LOE edx ecx ebx ebp esi xmm0 xmm2 xmm3 xmm4
.B4.4:                          ; Preds .B4.4 .B4.3
  0270d 8d 3c 76         lea edi, DWORD PTR [esi+esi*2]         
  02710 46               inc esi                                
  02711 c1 e7 04         shl edi, 4                             
  02714 3b f2            cmp esi, edx                           
  02716 f3 0f 6f 3c 39   movdqu xmm7, XMMWORD PTR [ecx+edi]     
  0271b f3 0f 6f 74 3b 
        10               movdqu xmm6, XMMWORD PTR [16+ebx+edi]  

;;; 	xmm4 = xmmloadu(p+2*16);

  02721 f3 0f 6f 6c 39 
        20               movdqu xmm5, XMMWORD PTR [32+ecx+edi]  

;;; 	xmm5 = xmmloadu(p+2*16+Second_Line_Offset);
;;; 		hash32xmm = _mm_mul_epu32(_mm_xor_si128(hash32xmm , (_mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1))) , PRIMExmm);       

  02727 66 0f 6f cf      movdqa xmm1, xmm7                      
  0272b 66 0f 73 f9 05   pslldq xmm1, 5                         
  02730 66 0f 73 df 7b   psrldq xmm7, 123                       
  02735 66 0f eb cf      por xmm1, xmm7                         
  02739 f3 0f 6f 3c 3b   movdqu xmm7, XMMWORD PTR [ebx+edi]     
  0273e 66 0f ef cf      pxor xmm1, xmm7                        
  02742 66 0f ef d1      pxor xmm2, xmm1                        

;;; 		hash32Bxmm = _mm_mul_epu32(_mm_xor_si128(hash32Bxmm , (_mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2))) , PRIMExmm);        

  02746 66 0f 6f ce      movdqa xmm1, xmm6                      
  0274a 66 0f 73 f9 05   pslldq xmm1, 5                         
  0274f 66 0f 73 de 7b   psrldq xmm6, 123                       
  02754 66 0f eb ce      por xmm1, xmm6                         
  02758 f3 0f 6f 74 39 
        10               movdqu xmm6, XMMWORD PTR [16+ecx+edi]  
  0275e 66 0f f4 d0      pmuludq xmm2, xmm0                     
  02762 66 0f ef ce      pxor xmm1, xmm6                        

;;; 		hash32Cxmm = _mm_mul_epu32(_mm_xor_si128(hash32Cxmm , (_mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5))) , PRIMExmm);      

  02766 66 0f 6f f5      movdqa xmm6, xmm5                      
  0276a 66 0f 73 fe 05   pslldq xmm6, 5                         
  0276f 66 0f ef d9      pxor xmm3, xmm1                        
  02773 66 0f 73 dd 7b   psrldq xmm5, 123                       
  02778 66 0f eb f5      por xmm6, xmm5                         
  0277c f3 0f 6f 6c 3b 
        20               movdqu xmm5, XMMWORD PTR [32+ebx+edi]  
  02782 66 0f f4 d8      pmuludq xmm3, xmm0                     
  02786 66 0f ef f5      pxor xmm6, xmm5                        
  0278a 66 0f ef e6      pxor xmm4, xmm6                        
  0278e 66 0f f4 e0      pmuludq xmm4, xmm0                     
  02792 0f 82 75 ff ff 
        ff               jb .B4.4 ; Prob 82%      

// ==================================== [ SSE4.1 ] ====================================

;;; #else
;;; 
;;; 	xmm0 = xmmloadu(p+0*16);
;;; 	xmm1 = xmmloadu(p+0*16+Second_Line_Offset);
;;; 	xmm2 = xmmloadu(p+1*16);
;;; 	xmm3 = xmmloadu(p+1*16+Second_Line_Offset);

  0270b 03 d9            add ebx, ecx                           
                                ; LOE edx ecx ebx ebp esi xmm0 xmm2 xmm3 xmm4
.B4.4:                          ; Preds .B4.4 .B4.3
  0270d 8d 3c 76         lea edi, DWORD PTR [esi+esi*2]         
  02710 46               inc esi                                
  02711 c1 e7 04         shl edi, 4                             
  02714 3b f2            cmp esi, edx                           
  02716 f3 0f 6f 3c 39   movdqu xmm7, XMMWORD PTR [ecx+edi]     
  0271b f3 0f 6f 74 3b 
        10               movdqu xmm6, XMMWORD PTR [16+ebx+edi]  

;;; 	xmm4 = xmmloadu(p+2*16);

  02721 f3 0f 6f 6c 39 
        20               movdqu xmm5, XMMWORD PTR [32+ecx+edi]  

;;; 	xmm5 = xmmloadu(p+2*16+Second_Line_Offset);
;;; 		//hash32xmm = _mm_mul_epu32(_mm_xor_si128(hash32xmm , (_mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1))) , PRIMExmm);       
;;; 		//hash32Bxmm = _mm_mul_epu32(_mm_xor_si128(hash32Bxmm , (_mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2))) , PRIMExmm);        
;;; 		//hash32Cxmm = _mm_mul_epu32(_mm_xor_si128(hash32Cxmm , (_mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5))) , PRIMExmm);      
;;; 		//??? crashes ???: My CPU T7500 supports up to SSSE3 but not 4.1:
;;; 		hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , (_mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1))) , PRIMExmm);       

  02727 66 0f 6f cf      movdqa xmm1, xmm7                      
  0272b 66 0f 73 f9 05   pslldq xmm1, 5                         
  02730 66 0f 73 df 7b   psrldq xmm7, 123                       
  02735 66 0f eb cf      por xmm1, xmm7                         
  02739 f3 0f 6f 3c 3b   movdqu xmm7, XMMWORD PTR [ebx+edi]     
  0273e 66 0f ef cf      pxor xmm1, xmm7                        
  02742 66 0f ef d1      pxor xmm2, xmm1                        

;;; 		hash32Bxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Bxmm , (_mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2))) , PRIMExmm);        

  02746 66 0f 6f ce      movdqa xmm1, xmm6                      
  0274a 66 0f 73 f9 05   pslldq xmm1, 5                         
  0274f 66 0f 73 de 7b   psrldq xmm6, 123                       
  02754 66 0f eb ce      por xmm1, xmm6                         
  02758 f3 0f 6f 74 39 
        10               movdqu xmm6, XMMWORD PTR [16+ecx+edi]  
  0275e 66 0f ef ce      pxor xmm1, xmm6                        

;;; 		hash32Cxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Cxmm , (_mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5))) , PRIMExmm);      

  02762 66 0f 6f f5      movdqa xmm6, xmm5                      
  02766 66 0f 73 fe 05   pslldq xmm6, 5                         
  0276b 66 0f ef d9      pxor xmm3, xmm1                        
  0276f 66 0f 73 dd 7b   psrldq xmm5, 123                       
  02774 66 0f eb f5      por xmm6, xmm5                         
  02778 f3 0f 6f 6c 3b 
        20               movdqu xmm5, XMMWORD PTR [32+ebx+edi]  
  0277e 66 0f ef f5      pxor xmm6, xmm5                        
  02782 66 0f ef e6      pxor xmm4, xmm6                        
  02786 66 0f 38 40 d0   pmulld xmm2, xmm0                      
  0278b 66 0f 38 40 d8   pmulld xmm3, xmm0                      
  02790 66 0f 38 40 e0   pmulld xmm4, xmm0                      
  02795 0f 82 72 ff ff 
        ff               jb .B4.4 ; Prob 82%                    

*/
		hash32Bxmm = _mm_mul_epu32(_mm_xor_si128(hash32xmm , _rotl_KAZE128(hash32Bxmm,5)) , PRIMExmm);       
		//hash32Bxmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , _rotl_KAZE128(hash32Bxmm,5)) , PRIMExmm);       
		hash32 = hash32Bxmm.m128i_u32[0] ^ hash32Bxmm.m128i_u32[1] ^ hash32Bxmm.m128i_u32[2] ^ hash32Bxmm.m128i_u32[3];
		hash32Cxmm = _mm_mul_epu32(_mm_xor_si128(hash32xmm , _rotl_KAZE128(hash32Cxmm,5)) , PRIMExmm);       
		//hash32Cxmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , _rotl_KAZE128(hash32Cxmm,5)) , PRIMExmm);       
		hash32 += hash32Cxmm.m128i_u32[0] ^ hash32Cxmm.m128i_u32[1] ^ hash32Cxmm.m128i_u32[2] ^ hash32Cxmm.m128i_u32[3];
#else
		hash32 = (hash32 ^ _rotl_KAZE(hash32C,5) ) * PRIME;
#endif
} else if (wrdlen >= 24) {
    Loop_Counter = (wrdlen/24);
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(3*4);
    for(; Loop_Counter; Loop_Counter--, p += 3*sizeof(uint32_t)) {
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+8+Second_Line_Offset))) * PRIME;        
    }
		hash32 = (hash32 ^ _rotl_KAZE(hash32C,5) ) * PRIME;
} else {
    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;
}
    hash32 = (hash32 ^ _rotl_KAZE(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}


//Wanted to see how SIMDed main loop would look like:
//One of the main goals: to stress 128bit registers only and nothing else, for now 6 in total, in fact Intel uses the all 8.
//Current approach: instead of rotating the 5 bits within the DWORD quadruplets I chose to do it within the entire DQWORD i.e. XMMWORD.
//Length of the main loop: 02795 - 0270d + 6 = 142 bytes
//CRASH CARAMBA: My CPU T7500 supports up to SSSE3 but not SSE4.1, I need new machine.

// #define xmmloadu(p) _mm_loadu_si128((__m128i const*)(p))
// #define _rotl_KAZE128(x, n) _mm_or_si128(_mm_slli_si128(x, n) , _mm_srli_si128(x, 128-n))
// uint32_t FNV1A_Hash_YoshimitsuTRIADiiXMM(const char *str, uint32_t wrdlen)
// {
//	const char *p = str;
// ...
// if (wrdlen >= 4*24) {  // Actually 4*24 is the minimum and not useful, 200++ makes more sense.
// 	Loop_Counter = (wrdlen/(4*24));
//	Loop_Counter++;
//	Second_Line_Offset = wrdlen-(Loop_Counter)*(4*3*4);
//	for(; Loop_Counter; Loop_Counter--, p += 4*3*sizeof(uint32_t)) {
// 		xmm0 = xmmloadu(p+0*16);
// 		xmm1 = xmmloadu(p+0*16+Second_Line_Offset);
// 		xmm2 = xmmloadu(p+1*16);
// 		xmm3 = xmmloadu(p+1*16+Second_Line_Offset);
// 		xmm4 = xmmloadu(p+2*16);
// 		xmm5 = xmmloadu(p+2*16+Second_Line_Offset);
// 		hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , (_mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1))) , PRIMExmm);       
// 		hash32Bxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Bxmm , (_mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2))) , PRIMExmm);        
// 		hash32Cxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Cxmm , (_mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5))) , PRIMExmm);      
//	}
// 	// The simplest mumbo-jumbo mix:
// 	hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , _rotl_KAZE128(hash32Bxmm,5))) , PRIMExmm);       
// 	hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , _rotl_KAZE128(hash32Cxmm,5))) , PRIMExmm);       
// 	hash32 = hash32xmm.m128i_u32[0] ^ hash32xmm.m128i_u32[1] ^ hash32xmm.m128i_u32[2] ^ hash32xmm.m128i_u32[3];
//	return hash32;
// } else if (wrdlen >= 24) {
// ...
// }

/*
; mark_description "Intel(R) C++ Compiler XE for applications running on IA-32, Version 12.1.1.258 Build 20111011";
; mark_description "-Ox -TcHASH_linearspeed_FURY.c -FaHASH_linearspeed_FURY_Intel_IA-32_12 -FA";

.B4.4:
        lea       edi, DWORD PTR [esi+esi*2]                    
        inc       esi                                           
        shl       edi, 4                                        
        cmp       esi, edx                                      
        movdqu    xmm7, XMMWORD PTR [ecx+edi]                   
        movdqu    xmm6, XMMWORD PTR [16+ebx+edi]                
        movdqu    xmm5, XMMWORD PTR [32+ecx+edi]                
        movdqa    xmm1, xmm7                                    
        pslldq    xmm1, 5                                       
        psrldq    xmm7, 123                                     
        por       xmm1, xmm7                                    
        movdqu    xmm7, XMMWORD PTR [ebx+edi]                   
        pxor      xmm1, xmm7                                    
        pxor      xmm2, xmm1                                    
        movdqa    xmm1, xmm6                                    
        pslldq    xmm1, 5                                       
        psrldq    xmm6, 123                                     
        por       xmm1, xmm6                                    
        movdqu    xmm6, XMMWORD PTR [16+ecx+edi]                
        pxor      xmm1, xmm6                                    
        movdqa    xmm6, xmm5                                    
        pslldq    xmm6, 5                                       
        pxor      xmm3, xmm1                                    
        psrldq    xmm5, 123                                     
        por       xmm6, xmm5                                    
        movdqu    xmm5, XMMWORD PTR [32+ebx+edi]                
        pxor      xmm6, xmm5                                    
        pxor      xmm4, xmm6                                    
        pmulld    xmm2, xmm0                                    
        pmulld    xmm3, xmm0                                    
        pmulld    xmm4, xmm0                                    
        jb        .B4.4
*/

// emmintrin.h
// Principal header file for Intel(R) Pentium(R) 4 processor SSE2 intrinsics
//extern __m128i __ICL_INTRINCC _mm_mulhi_epi16(__m128i, __m128i);
//extern __m128i __ICL_INTRINCC _mm_mulhi_epu16(__m128i, __m128i);
//extern __m128i __ICL_INTRINCC _mm_mullo_epi16(__m128i, __m128i);
//extern __m128i __ICL_INTRINCC _mm_mul_epu32(__m128i, __m128i);

// smmintrin.h
// SSE4.1 intrinsics
// Packed integer 32-bit multiplication with truncation of upper halves of results:
//extern __m128i __ICL_INTRINCC _mm_mullo_epi32(__m128i, __m128i);
// Packed integer 32-bit multiplication of 2 pairs of operands producing two 64-bit results:
//extern __m128i __ICL_INTRINCC _mm_mul_epi32(__m128i, __m128i);

// immintrin.h
// Intel(R) AVX compiler intrinsics.
//extern __m256i __cdecl _mm256_mullo_epi32(__m256i, __m256i);
//extern __m256i __cdecl _mm256_mul_epu32(__m256i, __m256i);
//extern __m256i __cdecl _mm256_mul_epi32(__m256i, __m256i);
//...
//    __int8              m256i_i8[32];
//    __int16             m256i_i16[16];
//    __int32             m256i_i32[8];
//    __int64             m256i_i64[4];
//    unsigned __int8     m256i_u8[32];
//    unsigned __int16    m256i_u16[16];
//    unsigned __int32    m256i_u32[8];
//    unsigned __int64    m256i_u64[4];
//} __m256i;
//
// Move Aligned Packed Integer Values
// **** VMOVDQA ymm1, m256
// **** VMOVDQA m256, ymm1
// Moves 256 bits of packed integer values from the source operand to the destination:
//extern __m256i __ICL_INTRINCC _mm256_load_si256(__m256i const *);
//extern void    __ICL_INTRINCC _mm256_store_si256(__m256i *, __m256i);
//
// Move Unaligned Packed Integer Values
// **** VMOVDQU ymm1, m256
// **** VMOVDQU m256, ymm1
// Moves 256 bits of packed integer values from the source operand to the destination:
//extern __m256i __ICL_INTRINCC _mm256_loadu_si256(__m256i const *);
//extern void    __ICL_INTRINCC _mm256_storeu_si256(__m256i *, __m256i);

// VMOVDQA sounds to me almost as JAMIRAQUAI - the wierdest hat artist, you know.




// FNV1A_YoshimitsuTRIADiiXMMx2 (revision 2 of FNV1A_YoshimitsuTRIADiiXMM, just unrolled once) aka FNV1A_penumbra, copyleft 2013-Jun-15 Kaze.
// PENUMBRA: Any partial shade or shadow round a thing; a surrounding area of uncertain extent (lit. & fig.). [mod. Latin, from Latin paene almost + umbra shadow.] 
//
// Hoy en mi ventana brilla el sol / The sun shines through my window today
// Y el corazn se pone triste contemplando la ciudad / And my heart feels sad while contemplating the city
// Porque te vas / Because you are leaving
// Como cada noche despert pensando en ti / Just like every night, I woke up thinking of you
// Y en mi reloj todas las horas vi pasar / And I saw as all the hours passed by in my clock
// Porque te vas / Because you are leaving
// Todas las promesas de mi amor se irn contigo / All my love promises will be gone with you
// Me olvidaras, me olvidaras / You will forget me, you will forget me
// Junto a la estacin llorar igual que un nio / Next to the station I will cry like a child
// Porque te vas, porque te vas / Because you are leaving, because you are leaving
// Bajo la penumbra de un farol se dormirn / Under the shadow of a street lamp they will sleep
// Todas las cosas que quedaron por decir se dormirn / All the things left unsaid will sleep there
// Junto a las manillas de un reloj esperarn / They will wait next to a clock's hands
// Todas las horas que quedaron por vivir esperarn / They will wait for all those hours that we had yet to live
// /J[e]anette - 'Porque te vas' lyrics/
//
// Many dependencies, many mini-goals, many restrictions... Blah-blah-blah...
// Yet in my amateurish view the NIFTIEST HT lookups function emerged, it is FNV1A_YoshimitsuTRIADii.
// Main feature: general purpose HT lookups function targeted as 32bit code and 32bit stamp, superfast for 'any length' keys, escpecially useful for text messages.
//
//#include <emmintrin.h> //SSE2
//#include <smmintrin.h> //SSE4.1
//#include <immintrin.h> //AVX
#define xmmload(p) _mm_load_si128((__m128i const*)(p))
#define xmmloadu(p) _mm_loadu_si128((__m128i const*)(p))
#define _rotl_KAZE128(x, n) _mm_or_si128(_mm_slli_si128(x, n) , _mm_srli_si128(x, 128-n))
#define _rotl_KAZE32(x, n) (((x) << (n)) | ((x) >> (32-(n))))
#define XMM_KAZE_SSE2
// For better mixing the above 'define' should be commented while the next one uncommented!
//#define XMM_KAZE_SSE4
uint32_t FNV1A_penumbra(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    const char *p = str;
    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

#if defined(XMM_KAZE_SSE2) || defined(XMM_KAZE_SSE4) || defined(XMM_KAZE_AVX)
    __m128i xmm0;   // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm1;   // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm2;   // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm3;   // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm4;   // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm5;   // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm0nd; // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm1nd; // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm2nd; // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm3nd; // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm4nd; // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i xmm5nd; // Defined for clarity: No need of defining it, the compiler sees well and uses no intermediate.
    __m128i hash32xmm = _mm_set1_epi32(2166136261);
    __m128i hash32Bxmm = _mm_set1_epi32(2166136261);
    __m128i hash32Cxmm = _mm_set1_epi32(2166136261);
    __m128i PRIMExmm = _mm_set1_epi32(709607);
#endif

#if defined(XMM_KAZE_SSE2) || defined(XMM_KAZE_SSE4) || defined(XMM_KAZE_AVX)
if (wrdlen >= 2*4*24) { // Actually 2*4*24 is the minimum and not useful, 200++ makes more sense.
    Loop_Counter = (wrdlen/(2*4*24));
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(2*4*3*4);
    for(; Loop_Counter; Loop_Counter--, p += 2*4*3*sizeof(uint32_t)) {
	xmm0 = xmmloadu(p+0*16);
	xmm1 = xmmloadu(p+0*16+Second_Line_Offset);
	xmm2 = xmmloadu(p+1*16);
	xmm3 = xmmloadu(p+1*16+Second_Line_Offset);
	xmm4 = xmmloadu(p+2*16);
	xmm5 = xmmloadu(p+2*16+Second_Line_Offset);
	xmm0nd = xmmloadu(p+3*16);
	xmm1nd = xmmloadu(p+3*16+Second_Line_Offset);
	xmm2nd = xmmloadu(p+4*16);
	xmm3nd = xmmloadu(p+4*16+Second_Line_Offset);
	xmm4nd = xmmloadu(p+5*16);
	xmm5nd = xmmloadu(p+5*16+Second_Line_Offset);
#if defined(XMM_KAZE_SSE2)
		hash32xmm = _mm_mullo_epi16(_mm_xor_si128(hash32xmm , _mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1)) , PRIMExmm);       
		hash32Bxmm = _mm_mullo_epi16(_mm_xor_si128(hash32Bxmm , _mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2)) , PRIMExmm);        
		hash32Cxmm = _mm_mullo_epi16(_mm_xor_si128(hash32Cxmm , _mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5)) , PRIMExmm);      
		hash32xmm = _mm_mullo_epi16(_mm_xor_si128(hash32xmm , _mm_xor_si128(_rotl_KAZE128(xmm0nd,5) , xmm1nd)) , PRIMExmm);       
		hash32Bxmm = _mm_mullo_epi16(_mm_xor_si128(hash32Bxmm , _mm_xor_si128(_rotl_KAZE128(xmm3nd,5) , xmm2nd)) , PRIMExmm);        
		hash32Cxmm = _mm_mullo_epi16(_mm_xor_si128(hash32Cxmm , _mm_xor_si128(_rotl_KAZE128(xmm4nd,5) , xmm5nd)) , PRIMExmm);      
#else
		hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , _mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1)) , PRIMExmm);       
		hash32Bxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Bxmm , _mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2)) , PRIMExmm);        
		hash32Cxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Cxmm , _mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5)) , PRIMExmm);      
		hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , _mm_xor_si128(_rotl_KAZE128(xmm0nd,5) , xmm1nd)) , PRIMExmm);       
		hash32Bxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Bxmm , _mm_xor_si128(_rotl_KAZE128(xmm3nd,5) , xmm2nd)) , PRIMExmm);        
		hash32Cxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Cxmm , _mm_xor_si128(_rotl_KAZE128(xmm4nd,5) , xmm5nd)) , PRIMExmm);      
#endif
    }
#if defined(XMM_KAZE_SSE2)
	hash32xmm = _mm_mullo_epi16(_mm_xor_si128(hash32xmm , hash32Bxmm) , PRIMExmm);       
 	hash32xmm = _mm_mullo_epi16(_mm_xor_si128(hash32xmm , hash32Cxmm) , PRIMExmm);       
#else
	hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , hash32Bxmm) , PRIMExmm);       
 	hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , hash32Cxmm) , PRIMExmm);       
#endif
	hash32 = (hash32 ^ hash32xmm.m128i_u32[0]) * PRIME;
	hash32B = (hash32B ^ hash32xmm.m128i_u32[3]) * PRIME;
	hash32 = (hash32 ^ hash32xmm.m128i_u32[1]) * PRIME;
	hash32B = (hash32B ^ hash32xmm.m128i_u32[2]) * PRIME;
} else if (wrdlen >= 24)
#else
if (wrdlen >= 24)
#endif
{
    Loop_Counter = (wrdlen/24);
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(3*4);
    for(; Loop_Counter; Loop_Counter--, p += 3*sizeof(uint32_t)) {
		hash32 = (hash32 ^ (_rotl_KAZE32(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE32(*(uint32_t *)(p+4+Second_Line_Offset),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE32(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+8+Second_Line_Offset))) * PRIME;        
    }
		hash32 = (hash32 ^ _rotl_KAZE32(hash32C,5) ) * PRIME;
} else {
    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		hash32 = (hash32 ^ (_rotl_KAZE32(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE32(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;
}
    hash32 = (hash32 ^ _rotl_KAZE32(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}
/*
Main loop, 345a-334e+1+7= 276 bytes, using SSE4:

; mark_description "Intel(R) C++ Compiler XE for applications running on IA-32, Version 12.1.1.258 Build 20111011";
; mark_description "-Ox -TcHASH_linearspeed_FURY.c -FaHASH_linearspeed_FURY_Intel_IA-32_12 -FAcs";

;;;     for(; Loop_Counter; Loop_Counter--, p += 2*4*3*sizeof(uint32_t)) {

  03346 85 d2            test edx, edx                          
  03348 0f 84 14 01 00 
        00               je .B5.6 
.B5.4:                          

;;; 	xmm0 = xmmloadu(p+0*16);

  0334e f3 0f 6f 09      movdqu xmm1, XMMWORD PTR [ecx]         

;;; 	xmm1 = xmmloadu(p+0*16+Second_Line_Offset);
;;; 	xmm2 = xmmloadu(p+1*16);
;;; 	xmm3 = xmmloadu(p+1*16+Second_Line_Offset);

  03352 f3 0f 6f 7c 19 
        10               movdqu xmm7, XMMWORD PTR [16+ecx+ebx]  

;;; 	xmm4 = xmmloadu(p+2*16);

  03358 f3 0f 6f 69 20   movdqu xmm5, XMMWORD PTR [32+ecx]      

;;; 	xmm5 = xmmloadu(p+2*16+Second_Line_Offset);
;;; 	xmm0nd = xmmloadu(p+3*16);

  0335d f3 0f 6f 61 30   movdqu xmm4, XMMWORD PTR [48+ecx]      

;;; 	xmm1nd = xmmloadu(p+3*16+Second_Line_Offset);
;;; 	xmm2nd = xmmloadu(p+4*16);
;;; 	xmm3nd = xmmloadu(p+4*16+Second_Line_Offset);
;;; 	xmm4nd = xmmloadu(p+5*16);
;;; 	xmm5nd = xmmloadu(p+5*16+Second_Line_Offset);
;;; #if defined(XMM_KAZE_SSE2)
;;; 		hash32xmm = _mm_mullo_epi16(_mm_xor_si128(hash32xmm , _mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1)) , PRIMExmm);       
;;; 		hash32Bxmm = _mm_mullo_epi16(_mm_xor_si128(hash32Bxmm , _mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2)) , PRIMExmm);        
;;; 		hash32Cxmm = _mm_mullo_epi16(_mm_xor_si128(hash32Cxmm , _mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5)) , PRIMExmm);      
;;; 		hash32xmm = _mm_mullo_epi16(_mm_xor_si128(hash32xmm , _mm_xor_si128(_rotl_KAZE128(xmm0nd,5) , xmm1nd)) , PRIMExmm);       
;;; 		hash32Bxmm = _mm_mullo_epi16(_mm_xor_si128(hash32Bxmm , _mm_xor_si128(_rotl_KAZE128(xmm3nd,5) , xmm2nd)) , PRIMExmm);        
;;; 		hash32Cxmm = _mm_mullo_epi16(_mm_xor_si128(hash32Cxmm , _mm_xor_si128(_rotl_KAZE128(xmm4nd,5) , xmm5nd)) , PRIMExmm);      
;;; #else
;;; 		hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , _mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1)) , PRIMExmm);       

  03362 66 0f 6f d1      movdqa xmm2, xmm1                      
  03366 66 0f 73 fa 05   pslldq xmm2, 5                         
  0336b 66 0f 73 d9 7b   psrldq xmm1, 123                       
  03370 66 0f eb d1      por xmm2, xmm1                         
  03374 f3 0f 6f 0c 19   movdqu xmm1, XMMWORD PTR [ecx+ebx]     
  03379 66 0f ef d1      pxor xmm2, xmm1                        

;;; 		hash32Bxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Bxmm , _mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2)) , PRIMExmm);        

  0337d 66 0f 6f cf      movdqa xmm1, xmm7                      
  03381 66 0f 73 f9 05   pslldq xmm1, 5                         
  03386 66 0f ef f2      pxor xmm6, xmm2                        
  0338a 66 0f 73 df 7b   psrldq xmm7, 123                       
  0338f 66 0f eb cf      por xmm1, xmm7                         
  03393 f3 0f 6f 79 10   movdqu xmm7, XMMWORD PTR [16+ecx]      
  03398 66 0f ef cf      pxor xmm1, xmm7                        

;;; 		hash32Cxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Cxmm , _mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5)) , PRIMExmm);      

  0339c 66 0f 6f fd      movdqa xmm7, xmm5                      
  033a0 66 0f 73 ff 05   pslldq xmm7, 5                         
  033a5 66 0f ef d9      pxor xmm3, xmm1                        
  033a9 66 0f 73 dd 7b   psrldq xmm5, 123                       
  033ae 66 0f eb fd      por xmm7, xmm5                         
  033b2 f3 0f 6f 6c 19 
        20               movdqu xmm5, XMMWORD PTR [32+ecx+ebx]  

;;; 		hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , _mm_xor_si128(_rotl_KAZE128(xmm0nd,5) , xmm1nd)) , PRIMExmm);       
;;; 		hash32Bxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Bxmm , _mm_xor_si128(_rotl_KAZE128(xmm3nd,5) , xmm2nd)) , PRIMExmm);        

  033b8 f3 0f 6f 4c 19 
        40               movdqu xmm1, XMMWORD PTR [64+ecx+ebx]  
  033be 66 0f ef fd      pxor xmm7, xmm5                        
  033c2 66 0f 6f ec      movdqa xmm5, xmm4                      
  033c6 66 0f 73 fd 05   pslldq xmm5, 5                         
  033cb 66 0f ef c7      pxor xmm0, xmm7                        
  033cf 66 0f 73 dc 7b   psrldq xmm4, 123                       
  033d4 66 0f eb ec      por xmm5, xmm4                         
  033d8 f3 0f 6f 64 19 
        30               movdqu xmm4, XMMWORD PTR [48+ecx+ebx]  

;;; 		hash32Cxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Cxmm , _mm_xor_si128(_rotl_KAZE128(xmm4nd,5) , xmm5nd)) , PRIMExmm);      

  033de f3 0f 6f 79 50   movdqu xmm7, XMMWORD PTR [80+ecx]      
  033e3 66 0f 6f 15 00 
        00 00 00         movdqa xmm2, XMMWORD PTR [_2il0floatpacket.65] 
  033eb 66 0f ef ec      pxor xmm5, xmm4                        
  033ef 66 0f 38 40 f2   pmulld xmm6, xmm2                      
  033f4 66 0f ef f5      pxor xmm6, xmm5                        
  033f8 66 0f 6f e9      movdqa xmm5, xmm1                      
  033fc 66 0f 73 fd 05   pslldq xmm5, 5                         
  03401 66 0f 73 d9 7b   psrldq xmm1, 123                       
  03406 66 0f eb e9      por xmm5, xmm1                         
  0340a 66 0f 6f cf      movdqa xmm1, xmm7                      
  0340e 66 0f 73 f9 05   pslldq xmm1, 5                         
  03413 66 0f 73 df 7b   psrldq xmm7, 123                       
  03418 f3 0f 6f 61 40   movdqu xmm4, XMMWORD PTR [64+ecx]      
  0341d 66 0f eb cf      por xmm1, xmm7                         
  03421 66 0f ef ec      pxor xmm5, xmm4                        
  03425 f3 0f 6f 7c 19 
        50               movdqu xmm7, XMMWORD PTR [80+ecx+ebx]  
  0342b 66 0f 38 40 da   pmulld xmm3, xmm2                      
  03430 66 0f ef cf      pxor xmm1, xmm7                        
  03434 66 0f 38 40 c2   pmulld xmm0, xmm2                      
  03439 66 0f ef dd      pxor xmm3, xmm5                        
  0343d 66 0f ef c1      pxor xmm0, xmm1                        
  03441 83 c1 60         add ecx, 96                            
  03444 66 0f 38 40 f2   pmulld xmm6, xmm2                      
  03449 4a               dec edx                                
  0344a 66 0f 38 40 da   pmulld xmm3, xmm2                      
  0344f 66 0f 38 40 c2   pmulld xmm0, xmm2                      
  03454 0f 85 f4 fe ff 
        ff               jne .B5.4 
.B5.5:                          
  0345a 66 0f 6f 0d 00 
        00 00 00         movdqa xmm1, XMMWORD PTR [_2il0floatpacket.65] 
.B5.6:                          
*/




// FNV1A_YoshimitsuTRIADiiXMM revision 1+ aka FNV1A_SaberFatigue, copyleft 2013-Apr-26 Kaze.
// Targeted purpose: x-gram table lookups for Leprechaun r17.
// Targeted machine: assuming SSE2 is present always - no non-SSE2 counterpart.
//#include <emmintrin.h> //SSE2
//#include <smmintrin.h> //SSE4.1
//#include <immintrin.h> //AVX
	//#define xmmload(p) _mm_load_si128((__m128i const*)(p))
	//#define xmmloadu(p) _mm_loadu_si128((__m128i const*)(p))
	//#define _rotl_KAZE128(x, n) _mm_or_si128(_mm_slli_si128(x, n) , _mm_srli_si128(x, 128-n))
	//#define _rotl_KAZE32(x, n) (((x) << (n)) | ((x) >> (32-(n))))
	//#define XMM_KAZE_SSE2
	//#define XMM_KAZE_SSE4
uint32_t FNV1A_Hash_YoshimitsuTRIADiiXMM(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    const char *p = str;
    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

#if defined(XMM_KAZE_SSE2) || defined(XMM_KAZE_SSE4) || defined(XMM_KAZE_AVX)
    __m128i xmm0;
    __m128i xmm1;
    __m128i xmm2;
    __m128i xmm3;
    __m128i xmm4;
    __m128i xmm5;
    __m128i hash32xmm = _mm_set1_epi32(2166136261);
    __m128i hash32Bxmm = _mm_set1_epi32(2166136261);
    __m128i hash32Cxmm = _mm_set1_epi32(2166136261);
    __m128i PRIMExmm = _mm_set1_epi32(709607);
#endif

#if defined(XMM_KAZE_SSE2) || defined(XMM_KAZE_SSE4) || defined(XMM_KAZE_AVX)
if (wrdlen >= 4*24) { // Actually 4*24 is the minimum and not useful, 200++ makes more sense.
    Loop_Counter = (wrdlen/(4*24));
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(4*3*4);
    for(; Loop_Counter; Loop_Counter--, p += 4*3*sizeof(uint32_t)) {
	xmm0 = xmmloadu(p+0*16);
	xmm1 = xmmloadu(p+0*16+Second_Line_Offset);
	xmm2 = xmmloadu(p+1*16);
	xmm3 = xmmloadu(p+1*16+Second_Line_Offset);
	xmm4 = xmmloadu(p+2*16);
	xmm5 = xmmloadu(p+2*16+Second_Line_Offset);
#if defined(XMM_KAZE_SSE2)
		hash32xmm = _mm_mullo_epi16(_mm_xor_si128(hash32xmm , _mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1)) , PRIMExmm);       
		hash32Bxmm = _mm_mullo_epi16(_mm_xor_si128(hash32Bxmm , _mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2)) , PRIMExmm);        
		hash32Cxmm = _mm_mullo_epi16(_mm_xor_si128(hash32Cxmm , _mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5)) , PRIMExmm);      
#else
		hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , _mm_xor_si128(_rotl_KAZE128(xmm0,5) , xmm1)) , PRIMExmm);       
		hash32Bxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Bxmm , _mm_xor_si128(_rotl_KAZE128(xmm3,5) , xmm2)) , PRIMExmm);        
		hash32Cxmm = _mm_mullo_epi32(_mm_xor_si128(hash32Cxmm , _mm_xor_si128(_rotl_KAZE128(xmm4,5) , xmm5)) , PRIMExmm);      
#endif
    }
#if defined(XMM_KAZE_SSE2)
	hash32xmm = _mm_mullo_epi16(_mm_xor_si128(hash32xmm , hash32Bxmm) , PRIMExmm);       
 	hash32xmm = _mm_mullo_epi16(_mm_xor_si128(hash32xmm , hash32Cxmm) , PRIMExmm);       
#else
	hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , hash32Bxmm) , PRIMExmm);       
 	hash32xmm = _mm_mullo_epi32(_mm_xor_si128(hash32xmm , hash32Cxmm) , PRIMExmm);       
#endif
	hash32 = (hash32 ^ hash32xmm.m128i_u32[0]) * PRIME;
	hash32B = (hash32B ^ hash32xmm.m128i_u32[3]) * PRIME;
	hash32 = (hash32 ^ hash32xmm.m128i_u32[1]) * PRIME;
	hash32B = (hash32B ^ hash32xmm.m128i_u32[2]) * PRIME;
} else if (wrdlen >= 24)
#else
if (wrdlen >= 24)
#endif
{
    Loop_Counter = (wrdlen/24);
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(3*4);
    for(; Loop_Counter; Loop_Counter--, p += 3*sizeof(uint32_t)) {
		hash32 = (hash32 ^ (_rotl_KAZE32(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE32(*(uint32_t *)(p+4+Second_Line_Offset),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE32(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+8+Second_Line_Offset))) * PRIME;        
    }
		hash32 = (hash32 ^ _rotl_KAZE32(hash32C,5) ) * PRIME;
} else {
    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		hash32 = (hash32 ^ (_rotl_KAZE32(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE32(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;
}
    hash32 = (hash32 ^ _rotl_KAZE32(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}














// Compile line:
// icl /Ox /TcHASH_linearspeed_FURY.c /FaHASH_linearspeed_FURY_Intel_IA-32_12 /FAcs
// 
// Fragment from the .COD file, Intel(R) C++ Compiler XE for applications running on IA-32, Version 12.1.1.258 Build 20111011:
// 
// .B4.4:                          ; Preds .B4.3 .B4.4
// 
// ;;; 		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
// 
//   0300c 8b 2b            mov ebp, DWORD PTR [ebx]               
//   0300e c1 c5 05         rol ebp, 5                             
//   03011 33 2c 33         xor ebp, DWORD PTR [ebx+esi]           
//   03014 33 fd            xor edi, ebp                           
// 
// ;;; 		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset),5) ^ *(uint32_t *)(p+4))) * PRIME;        
// 
//   03016 8b 6c 33 04      mov ebp, DWORD PTR [4+ebx+esi]         
//   0301a c1 c5 05         rol ebp, 5                             
//   0301d 33 6b 04         xor ebp, DWORD PTR [4+ebx]             
//   03020 33 cd            xor ecx, ebp                           
// 
// ;;; 		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+8+Second_Line_Offset))) * PRIME;        
// 
//   03022 8b 6b 08         mov ebp, DWORD PTR [8+ebx]             
//   03025 c1 c5 05         rol ebp, 5                             
//   03028 33 6c 33 08      xor ebp, DWORD PTR [8+ebx+esi]         
//   0302c 83 c3 0c         add ebx, 12                            
//   0302f 33 c5            xor eax, ebp                           
//   03031 69 ff e7 d3 0a 
//         00               imul edi, edi, 709607                  
//   03037 69 c9 e7 d3 0a 
//         00               imul ecx, ecx, 709607                  
//   0303d 69 c0 e7 d3 0a 
//         00               imul eax, eax, 709607                  
//   03043 4a               dec edx                                
//   03044 75 c6            jne .B4.4 ; Prob 82%                   
// 
// The main loop is 03044-0300c+2 = 58 bytes.

uint32_t FNV1A_Hash_YoshimitsuTRIADii(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    const char *p = str;
    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

if (wrdlen >= 24) {
    Loop_Counter = (wrdlen/24);
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(3*4);
    for(; Loop_Counter; Loop_Counter--, p += 3*sizeof(uint32_t)) {
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+8+Second_Line_Offset))) * PRIME;        
    }
		hash32 = (hash32 ^ _rotl_KAZE(hash32C,5) ) * PRIME;
} else {
    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;
}
    hash32 = (hash32 ^ _rotl_KAZE(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}


uint32_t FNV1A_Hash_YoshimitsuTRIAD(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    //uint32_t hash32D = 2166136261;
    const char *p = str;

    for(; wrdlen >= 3*2*sizeof(uint32_t); wrdlen -= 3*2*sizeof(uint32_t), p += 3*2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        
		//hash32D = (hash32D ^ (_rotl_KAZE(*(uint32_t *)(p+24),5) ^ *(uint32_t *)(p+28))) * PRIME;        

/*
// Microsoft (R) 32-bit C/C++ Optimizing Compiler Version 16.00.30319.01 for 80x86 gave this:
// 12d-0f4+2= 59 bytes, No CARAMBA anymore.
$LL9@FNV1A_Hash@2:

; 160  : 		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        

  000f4	8b 01		 mov	 eax, DWORD PTR [ecx]
  000f6	c1 c0 05	 rol	 eax, 5
  000f9	33 41 04	 xor	 eax, DWORD PTR [ecx+4]
  000fc	83 eb 18	 sub	 ebx, 24			; 00000018H
  000ff	33 f0		 xor	 esi, eax

; 161  : 		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        

  00101	8b 41 08	 mov	 eax, DWORD PTR [ecx+8]
  00104	69 f6 e7 d3 0a
	00		 imul	 esi, 709607		; 000ad3e7H
  0010a	c1 c0 05	 rol	 eax, 5
  0010d	33 41 0c	 xor	 eax, DWORD PTR [ecx+12]
  00110	83 c1 18	 add	 ecx, 24			; 00000018H
  00113	33 f8		 xor	 edi, eax

; 162  : 		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        

  00115	8b 41 f8	 mov	 eax, DWORD PTR [ecx-8]
  00118	69 ff e7 d3 0a
	00		 imul	 edi, 709607		; 000ad3e7H
  0011e	c1 c0 05	 rol	 eax, 5
  00121	33 41 fc	 xor	 eax, DWORD PTR [ecx-4]
  00124	33 e8		 xor	 ebp, eax
  00126	69 ed e7 d3 0a
	00		 imul	 ebp, 709607		; 000ad3e7H
  0012c	4a		 dec	 edx
  0012d	75 c5		 jne	 SHORT $LL9@FNV1A_Hash@2
*/

/*
// Intel(R) C++ Compiler XE for applications running on IA-32, Version 12.1.1.258 Build 20111011 gave this:
// 216a-212f+2= 61 bytes, No CARAMBA anymore.
;;;     for(; wrdlen >= 3*2*sizeof(uint32_t); wrdlen -= 3*2*sizeof(uint32_t), p += 3*2*sizeof(uint32_t)) {

  02127 83 fa 18         cmp edx, 24                            
  0212a 72 43            jb .B4.5 ; Prob 10%                    
                                ; LOE eax edx ecx ebx ebp esi edi
.B4.2:                          ; Preds .B4.1
  0212c 89 34 24         mov DWORD PTR [esp], esi               ;
                                ; LOE eax edx ecx ebx ebp edi
.B4.3:                          ; Preds .B4.2 .B4.3

;;; 		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        

  0212f 8b 31            mov esi, DWORD PTR [ecx]               
  02131 83 c2 e8         add edx, -24                           
  02134 c1 c6 05         rol esi, 5                             
  02137 33 71 04         xor esi, DWORD PTR [4+ecx]             
  0213a 33 de            xor ebx, esi                           

;;; 		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        

  0213c 8b 71 08         mov esi, DWORD PTR [8+ecx]             
  0213f c1 c6 05         rol esi, 5                             
  02142 33 71 0c         xor esi, DWORD PTR [12+ecx]            
  02145 33 fe            xor edi, esi                           

;;; 		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        

  02147 8b 71 10         mov esi, DWORD PTR [16+ecx]            
  0214a c1 c6 05         rol esi, 5                             
  0214d 33 71 14         xor esi, DWORD PTR [20+ecx]            
  02150 83 c1 18         add ecx, 24                            
  02153 33 ee            xor ebp, esi                           
  02155 69 db e7 d3 0a 
        00               imul ebx, ebx, 709607                  
  0215b 69 ff e7 d3 0a 
        00               imul edi, edi, 709607                  
  02161 69 ed e7 d3 0a 
        00               imul ebp, ebp, 709607                  
  02167 83 fa 18         cmp edx, 24                            
  0216a 73 c3            jae .B4.3 ; Prob 82%                   
                                ; LOE eax edx ecx ebx ebp edi
.B4.4:                          ; Preds .B4.3
  0216c 8b 34 24         mov esi, DWORD PTR [esp]               ;
                                ; LOE eax edx ecx ebx ebp esi edi
.B4.5:                          ; Preds .B4.1 .B4.4
*/

    }
	if (p != str) {
		hash32 = (hash32 ^ _rotl_KAZE(hash32C,5) ) * PRIME;
		//hash32B = (hash32B ^ _rotl_KAZE(hash32D,5) ) * PRIME;
	}

    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;

    hash32 = (hash32 ^ _rotl_KAZE(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}

/*
E:\_KAZE_hash_Yoshimitsu>hash KT5million.txt
5000000 lines read
16777216 elements in the table (24 bits)
           Jesteress:    5878779   5825146   5822662   5825058   5827247   5823323   5824758   5823078   5824349   5825287|   5822662 [676877]
              Meiyan:    5842086   5835613   5856486   5830202   5837501   5830725   5830964   5826998   5830249   5830946|   5826998 [676877]
             Yorikke:    5636294   5637254   5637179   5632624   5633680   5638724   5634415   5634464   5633547   5636053|   5632624 [677478]
          Yoshimitsu:    5669251   5671260   5675569   5674196   5671851   5669726   5671422   5668882   5672890   5669785|   5668882 [675312]
     YoshimitsuTRIAD:    5728430   5717094   5710968   5711649   5714960   5713744   5714511   5716452   5714930   5716363|   5710968 [676878]
E:\_KAZE_hash_Yoshimitsu>hash KTR5million.txt
5000000 lines read
16777216 elements in the table (24 bits)
           Jesteress:    6063204   6028778   6025752   6028069   6028171   6025632   6025023   6033669   6025947   6030192|   6025023 [676000]
              Meiyan:    6034847   6030337   6034264   6030977   6032888   6033059   6031514   6032200   6031543   6032151|   6030337 [676000]
             Yorikke:    5821302   5828744   5826117   5822931   5823511   5827977   5822589   5825228   5823429   5824151|   5821302 [676570]
          Yoshimitsu:    5869581   5869615   5866876   5866362   5866400   5868798   5866424   5867052   5897106   5866276|   5866276 [676009]
     YoshimitsuTRIAD:    5901110   5899394   5900676   5898885   5897596   5899814   5898372   5900176   5899548   5898672|   5897596 [676097]
E:\_KAZE_hash_Yoshimitsu>hash "Word-list_00,584,879_Russian_Spell-Check_Unknown-Quality.slv"
584879 lines read
2097152 elements in the table (21 bits)
           Jesteress:     331121    326649    325694    325921    325269    336903    323976    324122    324852    324885|    323976 [75404]
              Meiyan:     327273    327884    327191    327414    328120    326688    327380    327164    328259    327192|    326688 [75377]
             Yorikke:     325655    325293    325176    325648    325890    325201    325744    325313    324772    324387|    324387 [74661]
          Yoshimitsu:     338636    337185    336882    337006    336713    336885    336728    337510    337627    337016|    336713 [74661]
     YoshimitsuTRIAD:     343093    342237    342532    342846    342436    342446    342615    342407    342275    342305|    342237 [74661]
E:\_KAZE_hash_Yoshimitsu>hash "Word-list_12,561,874_wikipedia-en-html.tar.wrd"
12561874 lines read
33554432 elements in the table (25 bits)
           Jesteress:   10779327  10690650  10690299  10688678  10686600  10689742  10687440  10685120  10658052  10685582|  10658052 [2121868]
              Meiyan:   10672467  10668722  10868348  10672009  10670465  10668046  10668208  10631710  10667418  10634536|  10631710 [2111271]
             Yorikke:   10599446  10567401  10602688  10576836  10602350  10606826  10603392  10603198  10555782  10602996|  10555782 [2084954]
          Yoshimitsu:   10794577  10814809  10800927  10812653  10801237  10813175  10804918  10848550  10828053  10812376|  10794577 [2084954]
     YoshimitsuTRIAD:   10963283  10954044  10956452  10923493  10961516  10966310  10953907  10961490  10896792  10961839|  10896792 [2084931]
E:\_KAZE_hash_Yoshimitsu>hash "Word-list_22,202,980_wikipedia-de-en-es-fr-it-nl-pt-ro-html.tar.wrd"
22202980 lines read
67108864 elements in the table (26 bits)
           Jesteress:   20548340  20325730  20393503  20327776  20397562  20315709  20400938  20307680  20366481  20355343|  20307680 [3355676]
              Meiyan:   20380953  20446880  20394030  20383675  20389217  20445270  20342789  20331294  20445734  20393765|  20331294 [3345260]
             Yorikke:   20223329  20288434  20250608  20292158  20185216  20332074  20279183  20292202  20281696  20272448|  20185216 [3300245]
          Yoshimitsu:   20632787  20536618  20631049  20581010  20724361  20609390  20693189  20640113  20716798  20684694|  20536618 [3300245]
     YoshimitsuTRIAD:   20861385  20781243  21030573  20860420  20786991  20846755  20809567  20788323  20902398  20847700|  20781243 [3299941]
E:\_KAZE_hash_Yoshimitsu>hash 100MB_as_one_line.TXT
1 lines read
4 elements in the table (2 bits)
           Jesteress:     201410    201278    201313    201374    201289    201175    201320    201319    201300    204956    209246    201276    201316    201404    201547    2012
99    201221    201220    201303    201256    201700    201176    201529    201672    201309    202120    201325    201220    201415    201362    201323    201731    201332    2013
11    201274    201493    201349    201228    201225    201318|    201175 [    0]
              Meiyan:     201376    201343    201705    201187    201302    201362    201429    201482    201282    201306    201807    201269    201458    201829    201326    2014
18    201166    201487    201324    201233    201123    201372    201222    201345    201799    201250    201394    201351    201568    201318    201235    201294    201363    2013
09    201280    201779    201211    201297    201286    201405|    201123 [    0]
             Yorikke:     179798    179617    179642    179668    179915    179738    180173    179841    179680    179723    179749    180140    179750    179687    179743    1797
40    179702    179552    180281    179674    179738    179658    179871    179938    179742    179728    179692    179736    180066    179664    180293    179750    179822    1798
83    179654    179763    179660    179641    180188    179667|    179552 [    0]
          Yoshimitsu:     177954    177749    177781    211527    177927    177855    177981    178792    177931    177841    177857    177895    178036    177917    177933    1786
00    177869    177718    177856    177885    178252    177839    177760    177745    177873    184765    177829    178340    177895    177875    177987    177877    178357    1779
56    177676    177785    177776    177840    177839    178491|    177676 [    0]
     YoshimitsuTRIAD:     179692    179576    179787    179593    179851    179784    179680    179602    179611    179842    179666    179709    180739    179745    179815    1797
35    179537    180073    179661    179561    179542    179741    179608    179518    180282    179723    179663    179681    179823    180067    179672    179668    179711    1797
49    179530    179540    180106    179611    179637    179731|    179518 [    0]
E:\_KAZE_hash_Yoshimitsu>hash LP3.TXT
3333 lines read
8192 elements in the table (13 bits)
           Jesteress:        808       778       778       777       777       776       778       777       778       777       778       776       777       778       777       7
78       886       777       777       778       778       777       777       777       778       777       777       778       778       779       777       777       777       7
77       777       778       777       777       777       777|       776 [  576]
              Meiyan:        801       792       792       792       814       791       791       791       791       791       791       791       790       791       791       7
91       791       790       791       790       790       791       790       791       791       790       791       791       790       791       791       791       790       9
12       792       791       791       791       790       791|       790 [  583]
             Yorikke:        785       777       776       776       776       774       775       774       777       775       775       776       775       776       776       7
74       797       779       776       778       779       778       777       775       776       774       776       774       776       775       775       775       775       7
74       800       777       842       779       779       859|       774 [  579]
          Yoshimitsu:        822       799       798       797       798       797       792       794       794       794       794       794       793       794       794      12
13       844       799       795       797       798       797       793       794       794       794       793       792       793       794       794       794       793       7
94       816       799       797       795       796       875|       792 [  609]
     YoshimitsuTRIAD:        854       829       826       825       826       825       822       825       855       823       823       824       824       822       824       8
21       845       826       825       824       825       904       824       823       822       822       821       822       822       889       824       824       824       8
22       847       825       826       826       824       825|       821 [  615]
E:\_KAZE_hash_Yoshimitsu>
*/


// CRC_SlicingBy8

#define CRCPOLYK1 0xBA0DC66B //CRC-32K_0xBA0DC66B
#define CRCPOLYK2 0x90022004 //CRC-32K_0x90022004

#define CRCPOLYC1 0x82F63B78 //CRC-32C_0x82F63B78
#define CRCPOLYC2 0x8F6E37A0 //CRC-32C_0x8F6E37A0

//(0x82F63B78 vs 0xEDB88320)
#define CRCPOLYC 0x82F63B78
#define CRCPOLY 0xEDB88320
#define CRCINIT 0xFFFFFFFF
 
uint32_t g_crc_slicingK1[8][256];
uint32_t g_crc_slicingK2[8][256];
uint32_t g_crc_slicingC1[8][256];
uint32_t g_crc_slicingC2[8][256];
uint32_t g_crc_precalc[4][256]; // CRC-32

static uint32_t Min(uint32_t x, uint32_t y) {
    // Branchless minimum (from http://graphics.stanford.edu/~seander/bithacks.html#IntegerMinOrMax)
    //return y ^ ((x ^ y) & -(x < y));
     return (x < y) ? x : y; // CMOV is used when /arch:SSE2 is on
}

static void CRC_SlicingInitK1() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYK1 & (-(int)(x & 1)));
		g_crc_slicingK1[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingK1[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingK1[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingK1[j][i] = c;
		}
	}
}

static void CRC_SlicingInitK2() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYK2 & (-(int)(x & 1)));
		g_crc_slicingK2[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingK2[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingK2[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingK2[j][i] = c;
		}
	}
}

static void CRC_SlicingInitC1() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYC1 & (-(int)(x & 1)));
		g_crc_slicingC1[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingC1[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingC1[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingC1[j][i] = c;
		}
	}
}

static void CRC_SlicingInitC2() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYC2 & (-(int)(x & 1)));
		g_crc_slicingC2[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingC2[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingC2[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingC2[j][i] = c;
		}
	}
}


uint32_t CRC_SlicingBy8K1(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingK1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingK1[7][(crc      ) & 0xFF] ^
			g_crc_slicingK1[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingK1[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingK1[4][(crc >> 24)] ^
			g_crc_slicingK1[3][(next      ) & 0xFF] ^
			g_crc_slicingK1[2][(next >>  8) & 0xFF] ^
			g_crc_slicingK1[1][(next >> 16) & 0xFF] ^
			g_crc_slicingK1[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingK1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}

uint32_t CRC_SlicingBy8K2(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingK2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingK2[7][(crc      ) & 0xFF] ^
			g_crc_slicingK2[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingK2[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingK2[4][(crc >> 24)] ^
			g_crc_slicingK2[3][(next      ) & 0xFF] ^
			g_crc_slicingK2[2][(next >>  8) & 0xFF] ^
			g_crc_slicingK2[1][(next >> 16) & 0xFF] ^
			g_crc_slicingK2[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingK2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}

uint32_t CRC_SlicingBy8C1(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingC1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingC1[7][(crc      ) & 0xFF] ^
			g_crc_slicingC1[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingC1[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingC1[4][(crc >> 24)] ^
			g_crc_slicingC1[3][(next      ) & 0xFF] ^
			g_crc_slicingC1[2][(next >>  8) & 0xFF] ^
			g_crc_slicingC1[1][(next >> 16) & 0xFF] ^
			g_crc_slicingC1[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingC1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}

uint32_t CRC_SlicingBy8C2(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingC2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingC2[7][(crc      ) & 0xFF] ^
			g_crc_slicingC2[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingC2[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingC2[4][(crc >> 24)] ^
			g_crc_slicingC2[3][(next      ) & 0xFF] ^
			g_crc_slicingC2[2][(next >>  8) & 0xFF] ^
			g_crc_slicingC2[1][(next >> 16) & 0xFF] ^
			g_crc_slicingC2[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingC2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}


// CRC-32
//#define CRCPOLY 0xEDB88320
//#define CRCINIT 0xFFFFFFFF

void CRC32Init(void) {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for(i = 0; i <= 0xFF; i++) {
		x = i;
		for(j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLY & (-(int)(x & 1)));
		g_crc_precalc[0][i] = x;
	}

	for(i = 0; i <= 0xFF; i++) {
		c = g_crc_precalc[0][i];
		for(j = 1; j < 4; j++) {
			c = g_crc_precalc[0][c & 0xFF] ^ (c >> 8);
			g_crc_precalc[j][i] = c;
		}
	}
}

uint32_t CRC32(const char* key, uint32_t len) {
	uint32_t crc = CRCINIT;
	uint32_t ndwords = len / sizeof(uint32_t);
uint32_t c;
	for(; ndwords; ndwords--) {
		crc ^= *(uint32_t*)key;
		crc =
			g_crc_precalc[3][(crc      ) & 0xFF] ^
			g_crc_precalc[2][(crc >>  8) & 0xFF] ^
			g_crc_precalc[1][(crc >> 16) & 0xFF] ^
			g_crc_precalc[0][(crc >> 24) & 0xFF];
		key += sizeof(uint32_t);
	}
	if (len & sizeof(uint16_t)) {
		c = crc ^ *(uint16_t*)key;
		crc = g_crc_precalc[1][(c     ) & 0xFF] ^
			  g_crc_precalc[0][(c >> 8) & 0xFF] ^ (crc >> 16);
		key += sizeof(uint16_t);
	}
	//if (len & sizeof(BYTE))
	if (len & 1)
		crc = g_crc_precalc[0][(crc ^ *key) & 0xFF] ^ (crc >> 8);
	return ~crc;
}


void x64toaKAZE (      /* stdcall is faster and smaller... Might as well use it for the helper. */
        unsigned long long val,
        char *buf,
        unsigned radix,
        int is_neg
        )
{
        char *p;                /* pointer to traverse string */
        char *firstdig;         /* pointer to first digit */
        char temp;              /* temp char */
        unsigned digval;        /* value of digit */

        p = buf;

        if ( is_neg )
        {
            *p++ = '-';         /* negative, so output '-' and negate */
            val = (unsigned long long)(-(long long)val);
        }

        firstdig = p;           /* save pointer to first digit */

        do {
            digval = (unsigned) (val % radix);
            val /= radix;       /* get next digit */

            /* convert to ascii and store */
            if (digval > 9)
                *p++ = (char) (digval - 10 + 'a');  /* a letter */
            else
                *p++ = (char) (digval + '0');       /* a digit */
        } while (val > 0);

        /* We now have the digit of the number in the buffer, but in reverse
           order.  Thus we reverse them now. */

        *p-- = '\0';            /* terminate string; p points to last digit */

        do {
            temp = *p;
            *p = *firstdig;
            *firstdig = temp;   /* swap *p and *firstdig */
            --p;
            ++firstdig;         /* advance to next two digits */
        } while (firstdig < p); /* repeat until halfway */
}

/* Actual functions just call conversion helper with neg flag set correctly,
   and return pointer to buffer. */

char * _i64toaKAZE (
        long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE((unsigned long long)val, buf, radix, (radix == 10 && val < 0));
        return buf;
}

char * _ui64toaKAZE (
        unsigned long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE(val, buf, radix, 0);
        return buf;
}

char * _ui64toaKAZEzerocomma (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        do
                        { if (buf <= p)
                          { temp = *p;
                            buf[26-txpman] = temp; pxnman++;
                            p--;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          else
                          { buf[26-txpman] = (char) ('0'); pxnman++;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          txpman++;
                        } while (txpman <= 26);
        return buf;
}

char * _ui64toaKAZEcomma (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        while (buf <= p)
                        { temp = *p;
                          buf[26-txpman] = temp; pxnman++;
                          p--;
                          if (pxnman % 3 == 0 && buf <= p)
                          { txpman++;
                            buf[26-txpman] = (char) (',');
                          }
                          txpman++;
                        } 
        return buf+26-(txpman-1);
}

// Modified C Code by Kaze, original C Code by Kurt White.

// Can a knight placed on a chess board and jump to all 63 remaining squares
// only landing on each square once?
// Lets find out :)

#include <stdio.h>
#include <stdlib.h>

#include <time.h>

clock_t start,finish;
double duration;

/* List of valid moves a knight can make from any square */
int list[65][9] = { 0,0,0,0,0,0,0,0,0,
                                        11,18,0,0,0,0,0,0,0,    //1
                                        17,12,19,0,0,0,0,0,0,   //2
                                        9,13,18,20,0,0,0,0,0,   //3
                                        10,14,19,21,0,0,0,0,0,  //4
                                        15,11,20,22,0,0,0,0,0,  //5
                                        16,12,23,21,0,0,0,0,0,  //6
                                        24,13,22,0,0,0,0,0,0,   //7
                                        14,23,0,0,0,0,0,0,0,    //8
                                        3,26,19,0,0,0,0,0,0,    //9
                                        4,25,20,27,0,0,0,0,0,   //10
                                        1,5,17,26,21,28,0,0,0,  //11
                                        2,6,18,22,27,29,0,0,0,  //12
                                        7,3,23,19,28,30,0,0,0,  //13
                                        8,4,24,31,20,29,0,0,0,  //14
                                        5,32,21,30,0,0,0,0,0,   //15
                                        6,31,22,0,0,0,0,0,0,    //16
                                        2,11,34,27,0,0,0,0,0,   //17
                                        1,3,33,12,28,35,0,0,0,  //18
                                        2,9,4,25,13,34,29,36,0, //19
                                        3,5,10,14,26,30,35,37,0,//20
                                        4,6,15,11,31,27,36,38,0,//21
                                        7,16,5,32,12,39,28,37,0,//22
                                        8,6,40,13,29,38,0,0,0,  //23
                                        7,14,39,30,0,0,0,0,0,   //24
                                        10,42,19,35,0,0,0,0,0,  //25
                                        9,41,11,20,36,43,0,0,0, //26
                                        10,17,33,12,42,21,37,44,0, //27
                                        11,13,18,34,22,38,43,45,0, //28
                                        12,14,23,39,19,35,44,46,0, //29
                                        15,24,40,13,47,20,36,45,0, //30
                                        16,48,14,21,37,46,0,0,0,   //31
                                        15,47,22,38,0,0,0,0,0,  //32
                                        50,18,27,43,0,0,0,0,0,  //33
                                        49,17,51,19,28,44,0,0,0, //34
                                        25,41,50,52,18,20,29,45,0, //35
                                        26,42,51,53,19,21,30,46,0, //36
                                        31,47,52,54,20,22,27,43,0, //37
                                        32,48,55,53,23,21,28,44,0, //38
                                        56,24,54,22,29,45,0,0,0, //39
                                        55,23,30,46,0,0,0,0,0,  //40
                                        58,26,51,35,0,0,0,0,0,  //41
                                        57,25,59,52,27,36,0,0,0, //42
                                        49,58,33,60,26,53,28,37,0, //43
                                        59,61,50,54,34,27,29,38,0, //44
                                        60,62,55,39,51,28,30,35,0, //45
                                        63,56,61,40,52,31,29,36,0, //46
                                        64,62,32,53,30,37,0,0,0, //47
                                        63,31,54,38,0,0,0,0,0,  //48
                                        59,34,43,0,0,0,0,0,0,   //49
                                        33,60,35,44,0,0,0,0,0,  //50
                                        57,61,41,34,36,45,0,0,0, //51
                                        58,62,42,35,37,46,0,0,0, //52
                                        63,59,47,36,38,43,0,0,0, //53
                                        64,48,60,39,37,44,0,0,0, //54
                                        40,61,38,45,0,0,0,0,0,  //55
                                        62,39,46,0,0,0,0,0,0,   //56
                                        42,51,0,0,0,0,0,0,0,    //57
                                        41,52,43,0,0,0,0,0,0,   //58
                                        49,42,53,44,0,0,0,0,0,  //59
                                        50,54,43,45,0,0,0,0,0,  //60
                                        55,51,44,46,0,0,0,0,0,  //61
                                        56,47,52,45,0,0,0,0,0,  //62
                                        48,53,46,0,0,0,0,0,0,   //63
                                        47,54,0,0,0,0,0,0,0     //64
};

//     1  2  3  4  5  6  7  8
// 0: 02 03 04 04 04 04 03 02
// 1: 03 04 06 06 06 06 04 03
// 2: 04 06 08 08 08 08 06 04
// 3: 04 06 08 08 08 08 06 04
// 4: 04 06 08 08 08 08 06 04
// 5: 04 06 08 08 08 08 06 04
// 6: 03 04 06 06 06 06 04 03
// 7: 02 03 04 04 04 04 03 02

char *EightDigitBINlist[256] = {
"00000000\0",
"00000001\0",
"00000010\0",
"00000011\0",
"00000100\0",
"00000101\0",
"00000110\0",
"00000111\0",
"00001000\0",
"00001001\0",
"00001010\0",
"00001011\0",
"00001100\0",
"00001101\0",
"00001110\0",
"00001111\0",
"00010000\0",
"00010001\0",
"00010010\0",
"00010011\0",
"00010100\0",
"00010101\0",
"00010110\0",
"00010111\0",
"00011000\0",
"00011001\0",
"00011010\0",
"00011011\0",
"00011100\0",
"00011101\0",
"00011110\0",
"00011111\0",
"00100000\0",
"00100001\0",
"00100010\0",
"00100011\0",
"00100100\0",
"00100101\0",
"00100110\0",
"00100111\0",
"00101000\0",
"00101001\0",
"00101010\0",
"00101011\0",
"00101100\0",
"00101101\0",
"00101110\0",
"00101111\0",
"00110000\0",
"00110001\0",
"00110010\0",
"00110011\0",
"00110100\0",
"00110101\0",
"00110110\0",
"00110111\0",
"00111000\0",
"00111001\0",
"00111010\0",
"00111011\0",
"00111100\0",
"00111101\0",
"00111110\0",
"00111111\0",
"01000000\0",
"01000001\0",
"01000010\0",
"01000011\0",
"01000100\0",
"01000101\0",
"01000110\0",
"01000111\0",
"01001000\0",
"01001001\0",
"01001010\0",
"01001011\0",
"01001100\0",
"01001101\0",
"01001110\0",
"01001111\0",
"01010000\0",
"01010001\0",
"01010010\0",
"01010011\0",
"01010100\0",
"01010101\0",
"01010110\0",
"01010111\0",
"01011000\0",
"01011001\0",
"01011010\0",
"01011011\0",
"01011100\0",
"01011101\0",
"01011110\0",
"01011111\0",
"01100000\0",
"01100001\0",
"01100010\0",
"01100011\0",
"01100100\0",
"01100101\0",
"01100110\0",
"01100111\0",
"01101000\0",
"01101001\0",
"01101010\0",
"01101011\0",
"01101100\0",
"01101101\0",
"01101110\0",
"01101111\0",
"01110000\0",
"01110001\0",
"01110010\0",
"01110011\0",
"01110100\0",
"01110101\0",
"01110110\0",
"01110111\0",
"01111000\0",
"01111001\0",
"01111010\0",
"01111011\0",
"01111100\0",
"01111101\0",
"01111110\0",
"01111111\0",
"10000000\0",
"10000001\0",
"10000010\0",
"10000011\0",
"10000100\0",
"10000101\0",
"10000110\0",
"10000111\0",
"10001000\0",
"10001001\0",
"10001010\0",
"10001011\0",
"10001100\0",
"10001101\0",
"10001110\0",
"10001111\0",
"10010000\0",
"10010001\0",
"10010010\0",
"10010011\0",
"10010100\0",
"10010101\0",
"10010110\0",
"10010111\0",
"10011000\0",
"10011001\0",
"10011010\0",
"10011011\0",
"10011100\0",
"10011101\0",
"10011110\0",
"10011111\0",
"10100000\0",
"10100001\0",
"10100010\0",
"10100011\0",
"10100100\0",
"10100101\0",
"10100110\0",
"10100111\0",
"10101000\0",
"10101001\0",
"10101010\0",
"10101011\0",
"10101100\0",
"10101101\0",
"10101110\0",
"10101111\0",
"10110000\0",
"10110001\0",
"10110010\0",
"10110011\0",
"10110100\0",
"10110101\0",
"10110110\0",
"10110111\0",
"10111000\0",
"10111001\0",
"10111010\0",
"10111011\0",
"10111100\0",
"10111101\0",
"10111110\0",
"10111111\0",
"11000000\0",
"11000001\0",
"11000010\0",
"11000011\0",
"11000100\0",
"11000101\0",
"11000110\0",
"11000111\0",
"11001000\0",
"11001001\0",
"11001010\0",
"11001011\0",
"11001100\0",
"11001101\0",
"11001110\0",
"11001111\0",
"11010000\0",
"11010001\0",
"11010010\0",
"11010011\0",
"11010100\0",
"11010101\0",
"11010110\0",
"11010111\0",
"11011000\0",
"11011001\0",
"11011010\0",
"11011011\0",
"11011100\0",
"11011101\0",
"11011110\0",
"11011111\0",
"11100000\0",
"11100001\0",
"11100010\0",
"11100011\0",
"11100100\0",
"11100101\0",
"11100110\0",
"11100111\0",
"11101000\0",
"11101001\0",
"11101010\0",
"11101011\0",
"11101100\0",
"11101101\0",
"11101110\0",
"11101111\0",
"11110000\0",
"11110001\0",
"11110010\0",
"11110011\0",
"11110100\0",
"11110101\0",
"11110110\0",
"11110111\0",
"11111000\0",
"11111001\0",
"11111010\0",
"11111011\0",
"11111100\0",
"11111101\0",
"11111110\0",
"11111111\0"
};

void play( int );
void winner( void );

int board[65] = {0}; /* the Chess board   */
int moves[65];       /* list of moves     */
int k = 0;           /* move counter      */
  char llTOaDigits[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits2[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits3[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits4[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits5[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  unsigned long long wincount = 0;
  unsigned long long Sequences = 0, Jumps = 0;
  int Verbose=0;
  #define KAZE_toupper(c) ( (((c) >= 'a') && ((c) <= 'z')) ? ((c) - 'a' + 'A') : (c) )
  #define KAZE_tolower(c) ( (((c) >= 'A') && ((c) <= 'Z')) ? ((c) - 'A' + 'a') : (c) )
  char Bunyo1, Bunyo2;
  //int KT;
  //unsigned long long KT;
  unsigned int KT;
  unsigned int KT2;

      char *pointerflush, *pointerflushUNALIGN;
      char *pointerflush2, *pointerflushUNALIGN2;
      char *pointerflush3, *pointerflushUNALIGN3;
      char *pointerflush4, *pointerflushUNALIGN4;
      char *pointerflush5, *pointerflushUNALIGN5;
      unsigned long memory_size;
      uint32_t Slot;
      char KTstring[128+1]; 
      char KTstringBRUTUS[128+1]; 
      uint32_t PseudoLinkedPointer=0;
      uint32_t MAXcollisionsAtSomeSlots=0;
      uint32_t MAXcollisionsAtSomeSlots2=0;
      uint32_t MAXcollisionsAtSomeSlots3=0;
      uint32_t MAXcollisionsAtSomeSlots4=0;
      uint32_t MAXcollisionsAtSomeSlots5=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM2=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM3=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM4=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM5=0;
      uint32_t HASHfreeSLOTS;
      uint32_t HASHfreeSLOTS2;
      uint32_t HASHfreeSLOTS3;
      uint32_t HASHfreeSLOTS4;
      uint32_t HASHfreeSLOTS5;
      uint64_t KT_DumpCounter=0;
      uint64_t xxhashstamp;

    __m128i xmm0;
    __m128i xmm1;
    __m128i xmm2;
    __m128i xmm3;
    __m128i xmm4;
    __m128i xmm5;
    __m128i xmm6;
    __m128i xmm7;

time_t t1, t2, t3;
clock_t clocks1, clocks2, clocks3, clocks4;
unsigned long long ticksTOTAL=0, ticksStart;


int main(int argc, char *argv[])
{
printf("HASH_linearspeed_FURY: FNV1A_YoshimitsuTRIADii vs CRC32_8slice, rev.8 written by Kaze.\n");
/*
printf("Note1: The size-and-speed of L1/L2/L3 cache affects FNV1A_Yorikke and mostly FNV1A_YoshimitsuTRIAD a lot!\n");
printf("Note2: Main loop of FNV1A_YoshimitsuTRIAD is 59/61 bytes for Microsoft/Intel respectively (/Ox used for both).\n");
printf("Note3: Here comes the code generated by Intel 12.1 for FNV1A_YoshimitsuTRIAD's main loop:\n");
printf(".B4.3:                          ; Preds .B4.2 .B4.3\n");
printf("\n");
printf(";;; 		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        \n");
printf("\n");
printf("  0212f 8b 31            mov esi, DWORD PTR [ecx]               \n");
printf("  02131 83 c2 e8         add edx, -24                           \n");
printf("  02134 c1 c6 05         rol esi, 5                             \n");
printf("  02137 33 71 04         xor esi, DWORD PTR [4+ecx]             \n");
printf("  0213a 33 de            xor ebx, esi                           \n");
printf("\n");
printf(";;; 		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        \n");
printf("\n");
printf("  0213c 8b 71 08         mov esi, DWORD PTR [8+ecx]             \n");
printf("  0213f c1 c6 05         rol esi, 5                             \n");
printf("  02142 33 71 0c         xor esi, DWORD PTR [12+ecx]            \n");
printf("  02145 33 fe            xor edi, esi                           \n");
printf("\n");
printf(";;; 		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        \n");
printf("\n");
printf("  02147 8b 71 10         mov esi, DWORD PTR [16+ecx]            \n");
printf("  0214a c1 c6 05         rol esi, 5                             \n");
printf("  0214d 33 71 14         xor esi, DWORD PTR [20+ecx]            \n");
printf("  02150 83 c1 18         add ecx, 24                            \n");
printf("  02153 33 ee            xor ebp, esi                           \n");
printf("  02155 69 db e7 d3 0a \n");
printf("        00               imul ebx, ebx, 709607                  \n");
printf("  0215b 69 ff e7 d3 0a \n");
printf("        00               imul edi, edi, 709607                  \n");
printf("  02161 69 ed e7 d3 0a \n");
printf("        00               imul ebp, ebp, 709607                  \n");
printf("  02167 83 fa 18         cmp edx, 24                            \n");
printf("  0216a 73 c3            jae .B4.3 ; Prob 82%      \n");

printf("Note4: Specs of my laptop:\n");
printf("OS: Windows XP 32bit\n");
printf("Motherboard Name: Toshiba Satellite L305  \n");
printf("CPU Type: Mobile DualCore Intel Core 2 Duo T7500  \n");
printf("CPU Alias: Merom  \n");
printf("CPU Clock: 2194.7 MHz (original: 2200 MHz)  \n");
printf("CPU Multiplier: 11x  \n");
printf("CPU FSB: 199.5 MHz (original: 200 MHz)  \n");
printf("Memory Bus: 332.5 MHz  \n");
printf("L1 Code Cache: 32 KB per core \n"); 
printf("L1 Data Cache: 32 KB per core  \n");
printf("L2 Cache: 4 MB (On-Die, ECC, ASC, Full-Speed)  \n");
printf("Memory Timings: 5-5-5-13 (CL-RCD-RP-RAS)  \n");
printf("Instruction Set: x86, x86-64, MMX, SSE, SSE2, SSE3, SSSE3  \n");
printf("Transistors: 291 million  \n");
printf("Process Technology: 8M, 65 nm, CMOS, Cu, Low-K Inter-Layer, 2nd Gen Strained Si  \n");
printf("Front Side Bus Properties:  \n");
printf("   Bus Type: Intel AGTL+  \n");
printf("   Bus Width: 64-bit  \n");
printf("   Real Clock: 200 MHz (QDR)  \n");
printf("   Effective Clock: 800 MHz  \n");
printf("   Bandwidth: 6400 MB/s  \n");
printf("Memory Bus Properties:  \n");
printf("   Bus Type: Dual DDR2 SDRAM \n"); 
printf("   Bus Width: 128-bit  \n");
printf("   DRAM:FSB Ratio: 10:6  \n");
printf("   Real Clock: 333 MHz (DDR)  \n");
printf("   Effective Clock: 667 MHz  \n");
printf("   Bandwidth: 10667 MB/s  \n");
printf("Note5: The results on my laptop running 32bit code by Intel 12.1 compiler (/Ox used):\n\n");

printf("Copying a 256MB block 1024 times i.e. 256GB READ + 256GB WRITTEN ...\n");
printf("memcpy(): (256MB block); 262144MB copied in 141320 clocks or 1.855MB per clock\n");
printf("\n");
printf("Fetching a 512MB block 1024 times i.e. 512GB ...\n");
printf("BURST_Read_4XMM128bit: (512MB block); 524288MB fetched in 107937 clocks or 4.857MB per clock\n");
printf("\n");
printf("Fetching a 512MB block 1024 times i.e. 512GB ...\n");
printf("BURST_Read_8XMM128bit: (512MB block); 524288MB fetched in 113053 clocks or 4.638MB per clock\n");
printf("\n");
printf("Fetching a 64MB block 8*1024 times i.e. 512GB ...\n");
printf("BURST_Read_4XMM128bit: (64MB block); 524288MB fetched in 107609 clocks or 4.872MB per clock\n");
printf("\n");
printf("Fetching a 64MB block 8*1024 times i.e. 512GB ...\n");
printf("BURST_Read_8XMM128bit: (64MB block); 524288MB fetched in 113163 clocks or 4.633MB per clock\n");
printf("\n");
printf("Fetching a 128KB block 4*1024*1024 times i.e. 512GB ...\n");
printf("BURST_Read_4XMM128bit: (128KB block); 524288MB fetched in 37565 clocks or 13.957MB per clock\n");
printf("\n");
printf("Fetching a 128KB block 4*1024*1024 times i.e. 512GB ...\n");
printf("BURST_Read_8XMM128bit: (128KB block); 524288MB fetched in 36379 clocks or 14.412MB per clock\n");
printf("\n");
printf("Fetching a 16KB block 8*4*1024*1024 times i.e. 512GB ...\n");
printf("BURST_Read_4XMM128bit: (16KB block); 524288MB fetched in 20436 clocks or 25.655MB per clock\n");
printf("\n");
printf("Fetching a 16KB block 8*4*1024*1024 times i.e. 512GB ...\n");
printf("BURST_Read_8XMM128bit: (16KB block); 524288MB fetched in 17472 clocks or 30.007MB per clock\n");
printf("\n");
printf("Fetching/Hashing a 64MB block 1024 times i.e. 64GB ...\n");
printf("BURST_Read_4DWORDS: (64MB block); 65536MB fetched in 15148 clocks or 4.326MB per clock\n");
printf("BURST_Read_8DWORDSi: (64MB block); 65536MB fetched in 14383 clocks or 4.556MB per clock\n");
printf("FNV1A_YoshimitsuTRIADii: (64MB block); 65536MB hashed in 14898 clocks or 4.399MB per clock\n");
printf("FNV1A_YoshimitsuTRIAD: (64MB block); 65536MB hashed in 15927 clocks or 4.115MB per clock\n");
printf("FNV1A_Yorikke: (64MB block); 65536MB hashed in 16427 clocks or 3.990MB per clock\n");
printf("FNV1A_Yoshimura: (64MB block); 65536MB hashed in 15085 clocks or 4.344MB per clock\n");
printf("CRC32_SlicingBy8K2: (64MB block); 65536MB hashed in 71558 clocks or 0.916MB per clock\n");
printf("\n");
printf("Fetching/Hashing a 2MB block 32*1024 times ...\n");
printf("BURST_Read_4DWORDS: (2MB block); 65536MB fetched in 9547 clocks or 6.865MB per clock\n");
printf("BURST_Read_8DWORDSi: (2MB block); 65536MB fetched in 8892 clocks or 7.370MB per clock\n");
printf("FNV1A_YoshimitsuTRIADii: (2MB block); 65536MB hashed in 9422 clocks or 6.956MB per clock\n");
printf("FNV1A_YoshimitsuTRIAD: (2MB block); 65536MB hashed in 9750 clocks or 6.722MB per clock\n");
printf("FNV1A_Yorikke: (2MB block); 65536MB hashed in 10187 clocks or 6.433MB per clock\n");
printf("FNV1A_Yoshimura: (2MB block); 65536MB hashed in 9984 clocks or 6.564MB per clock\n");
printf("CRC32_SlicingBy8K2: (2MB block); 65536MB hashed in 69764 clocks or 0.939MB per clock\n");
printf("\n");
printf("Fetching/Hashing a 128KB block 512*1024 times ...\n");
printf("BURST_Read_4DWORDS: (128KB block); 65536MB fetched in 9219 clocks or 7.109MB per clock\n");
printf("BURST_Read_8DWORDSi: (128KB block); 65536MB fetched in 10577 clocks or 6.196MB per clock\n");
printf("FNV1A_YoshimitsuTRIADii: (128KB block); 65536MB hashed in 10702 clocks or 6.124MB per clock\n");
printf("FNV1A_YoshimitsuTRIAD: (128KB block); 65536MB hashed in 9656 clocks or 6.787MB per clock\n");
printf("FNV1A_Yorikke: (128KB block); 65536MB hashed in 10093 clocks or 6.493MB per clock\n");
printf("FNV1A_Yoshimura: (128KB block); 65536MB hashed in 11248 clocks or 5.826MB per clock\n");
printf("CRC32_SlicingBy8K2: (128KB block); 65536MB hashed in 69779 clocks or 0.939MB per clock\n");
printf("\n");
printf("Fetching/Hashing a 16KB block 4*1024*1024 times ...\n");
printf("BURST_Read_4DWORDS: (16KB block); 65536MB fetched in 7878 clocks or 8.319MB per clock\n");
printf("BURST_Read_8DWORDSi: (16KB block); 65536MB fetched in 7893 clocks or 8.303MB per clock\n");
printf("FNV1A_YoshimitsuTRIADii: (16KB block); 65536MB hashed in 8893 clocks or 7.369MB per clock\n");
printf("FNV1A_YoshimitsuTRIAD: (16KB block); 65536MB hashed in 8954 clocks or 7.319MB per clock\n");
printf("FNV1A_Yorikke: (16KB block); 65536MB hashed in 9719 clocks or 6.743MB per clock\n");
printf("FNV1A_Yoshimura: (16KB block); 65536MB hashed in 9734 clocks or 6.733MB per clock\n");
printf("CRC32_SlicingBy8K2: (16KB block); 65536MB hashed in 69451 clocks or 0.944MB per clock\n");

printf("\n");

printf("The results on this computer:\n\n");
*/

memory_size = ( (1<<HashSizeInBits)*sizeof(uint32_t) ) + 1 + 64 +16;
printf( "Allocating HASH memory %luMB ... ", 2*(memory_size>>20) );
pointerflushUNALIGN = (char *)malloc( 2*memory_size );
if( pointerflushUNALIGN == NULL )
{ puts( "\nKnight-tour_r8dump_Yorikke: Needed memory allocation denied!\n" ); return( 1 ); }
pointerflush = pointerflushUNALIGN + 64 - (((size_t)pointerflushUNALIGN) % 64);

/*
Memory pool starting address: 006E0041 ... NOT 64 byte aligned, FAILURE

Info1: One second seems to have 998 clocks.
Info2: This CPU seems to be working at 2,191 MHz.

Fetching/Hashing a 64MB block 1024 times i.e. 64GB ...
BURST_Read_4DWORDS: (64MB block); 65536MB fetched in 16521 clocks or 3.967MB per clock
BURST_Read_8DWORDSi: (64MB block); 65536MB fetched in 15787 clocks or 4.151MB per clock
FNV1A_YoshimitsuTRIADiiXMM: (64MB block); 65536MB hashed in 15958 clocks or 4.107MB per clock
FNV1A_YoshimitsuTRIADii: (64MB block); 65536MB hashed in 17738 clocks or 3.695MB per clock
FNV1A_YoshimitsuTRIAD: (64MB block); 65536MB hashed in 18003 clocks or 3.640MB per clock
FNV1A_Yorikke: (64MB block); 65536MB hashed in 19593 clocks or 3.345MB per clock
FNV1A_Yoshimura: (64MB block); 65536MB hashed in 19235 clocks or 3.407MB per clock
CRC32_SlicingBy8K2: (64MB block); 65536MB hashed in 71745 clocks or 0.913MB per clock

Fetching/Hashing a 2MB block 32*1024 times ...
BURST_Read_4DWORDS: (2MB block); 65536MB fetched in 12277 clocks or 5.338MB per clock
BURST_Read_8DWORDSi: (2MB block); 65536MB fetched in 12839 clocks or 5.104MB per clock
FNV1A_YoshimitsuTRIADiiXMM: (2MB block); 65536MB hashed in 13370 clocks or 4.902MB per clock
FNV1A_YoshimitsuTRIADii: (2MB block); 65536MB hashed in 15741 clocks or 4.163MB per clock
FNV1A_YoshimitsuTRIAD: (2MB block); 65536MB hashed in 15803 clocks or 4.147MB per clock
FNV1A_Yorikke: (2MB block); 65536MB hashed in 17581 clocks or 3.728MB per clock
FNV1A_Yoshimura: (2MB block); 65536MB hashed in 17644 clocks or 3.714MB per clock
CRC32_SlicingBy8K2: (2MB block); 65536MB hashed in 69888 clocks or 0.938MB per clock

Fetching/Hashing a 128KB block 512*1024 times ...
BURST_Read_4DWORDS: (128KB block); 65536MB fetched in 12183 clocks or 5.379MB per clock
BURST_Read_8DWORDSi: (128KB block); 65536MB fetched in 13479 clocks or 4.862MB per clock
FNV1A_YoshimitsuTRIADiiXMM: (128KB block); 65536MB hashed in 13291 clocks or 4.931MB per clock
FNV1A_YoshimitsuTRIADii: (128KB block); 65536MB hashed in 15959 clocks or 4.107MB per clock
FNV1A_YoshimitsuTRIAD: (128KB block); 65536MB hashed in 15803 clocks or 4.147MB per clock
FNV1A_Yorikke: (128KB block); 65536MB hashed in 17597 clocks or 3.724MB per clock
FNV1A_Yoshimura: (128KB block); 65536MB hashed in 17675 clocks or 3.708MB per clock
CRC32_SlicingBy8K2: (128KB block); 65536MB hashed in 69841 clocks or 0.938MB per clock

Fetching/Hashing a 16KB block 4*1024*1024 times ...
BURST_Read_4DWORDS: (16KB block); 65536MB fetched in 11606 clocks or 5.647MB per clock
BURST_Read_8DWORDSi: (16KB block); 65536MB fetched in 12106 clocks or 5.414MB per clock
FNV1A_YoshimitsuTRIADiiXMM: (16KB block); 65536MB hashed in 13135 clocks or 4.989MB per clock
FNV1A_YoshimitsuTRIADii: (16KB block); 65536MB hashed in 15522 clocks or 4.222MB per clock
FNV1A_YoshimitsuTRIAD: (16KB block); 65536MB hashed in 15803 clocks or 4.147MB per clock
FNV1A_Yorikke: (16KB block); 65536MB hashed in 17643 clocks or 3.715MB per clock
FNV1A_Yoshimura: (16KB block); 65536MB hashed in 17738 clocks or 3.695MB per clock
CRC32_SlicingBy8K2: (16KB block); 65536MB hashed in 69841 clocks or 0.938MB per clock

Memory pool starting address: 00CA0040 ... 64 byte aligned, OK

Info1: One second seems to have 1,006 clocks.
Info2: This CPU seems to be working at 2,208 MHz.

Fetching/Hashing a 64MB block 1024 times i.e. 64GB ...
BURST_Read_4DWORDS: (64MB block); 65536MB fetched in 15163 clocks or 4.322MB per clock
BURST_Read_8DWORDSi: (64MB block); 65536MB fetched in 13962 clocks or 4.694MB per clock
FNV1A_YoshimitsuTRIADiiXMM: (64MB block); 65536MB hashed in 13790 clocks or 4.752MB per clock
FNV1A_YoshimitsuTRIADii: (64MB block); 65536MB hashed in 14555 clocks or 4.503MB per clock
FNV1A_YoshimitsuTRIAD: (64MB block); 65536MB hashed in 16021 clocks or 4.091MB per clock
FNV1A_Yorikke: (64MB block); 65536MB hashed in 16442 clocks or 3.986MB per clock
FNV1A_Yoshimura: (64MB block); 65536MB hashed in 14758 clocks or 4.441MB per clock
CRC32_SlicingBy8K2: (64MB block); 65536MB hashed in 71589 clocks or 0.915MB per clock

Fetching/Hashing a 2MB block 32*1024 times ...
BURST_Read_4DWORDS: (2MB block); 65536MB fetched in 9547 clocks or 6.865MB per clock
BURST_Read_8DWORDSi: (2MB block); 65536MB fetched in 9548 clocks or 6.864MB per clock
FNV1A_YoshimitsuTRIADiiXMM: (2MB block); 65536MB hashed in 7316 clocks or 8.958MB per clock
FNV1A_YoshimitsuTRIADii: (2MB block); 65536MB hashed in 9906 clocks or 6.616MB per clock
FNV1A_YoshimitsuTRIAD: (2MB block); 65536MB hashed in 9765 clocks or 6.711MB per clock
FNV1A_Yorikke: (2MB block); 65536MB hashed in 10172 clocks or 6.443MB per clock
FNV1A_Yoshimura: (2MB block); 65536MB hashed in 10498 clocks or 6.243MB per clock
CRC32_SlicingBy8K2: (2MB block); 65536MB hashed in 69764 clocks or 0.939MB per clock

Fetching/Hashing a 128KB block 512*1024 times ...
BURST_Read_4DWORDS: (128KB block); 65536MB fetched in 9250 clocks or 7.085MB per clock
BURST_Read_8DWORDSi: (128KB block); 65536MB fetched in 10577 clocks or 6.196MB per clock
FNV1A_YoshimitsuTRIADiiXMM: (128KB block); 65536MB hashed in 7332 clocks or 8.938MB per clock
FNV1A_YoshimitsuTRIADii: (128KB block); 65536MB hashed in 10702 clocks or 6.124MB per clock
FNV1A_YoshimitsuTRIAD: (128KB block); 65536MB hashed in 9672 clocks or 6.776MB per clock
FNV1A_Yorikke: (128KB block); 65536MB hashed in 10108 clocks or 6.484MB per clock
FNV1A_Yoshimura: (128KB block); 65536MB hashed in 11279 clocks or 5.810MB per clock
CRC32_SlicingBy8K2: (128KB block); 65536MB hashed in 69841 clocks or 0.938MB per clock

Fetching/Hashing a 16KB block 4*1024*1024 times ...
BURST_Read_4DWORDS: (16KB block); 65536MB fetched in 7878 clocks or 8.319MB per clock
BURST_Read_8DWORDSi: (16KB block); 65536MB fetched in 7894 clocks or 8.302MB per clock
FNV1A_YoshimitsuTRIADiiXMM: (16KB block); 65536MB hashed in 6973 clocks or 9.399MB per clock
FNV1A_YoshimitsuTRIADii: (16KB block); 65536MB hashed in 8908 clocks or 7.357MB per clock
FNV1A_YoshimitsuTRIAD: (16KB block); 65536MB hashed in 9094 clocks or 7.207MB per clock
FNV1A_Yorikke: (16KB block); 65536MB hashed in 9626 clocks or 6.808MB per clock
FNV1A_Yoshimura: (16KB block); 65536MB hashed in 9734 clocks or 6.733MB per clock
CRC32_SlicingBy8K2: (16KB block); 65536MB hashed in 69451 clocks or 0.944MB per clock
*/

	//pointerflush++; //Misalign/Disalign/Unalign
//offset=64-int((long)data&63);
printf( "OK\n");
memset(pointerflush, 0, (1<<HashSizeInBits)*sizeof(uint32_t));
printf("\nMemory pool starting address: %p ... ", pointerflush);
if (((uintptr_t)(const void *)pointerflush & (64 - 1)) == 0) printf( "64 byte aligned, OK\n"); else printf( "NOT 64 byte aligned, FAILURE\n");

// ]


CRC_SlicingInitK2();

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	(void) time(&t1);
	(void) time(&t3);
	while (t3 == t1) (void) time(&t3);
	t1=t3;
	clocks1 = clock();
#if defined(_icl_mumbo_jumbo_)
ticksStart = GetRDTSC();
#endif
	while (t3 != t1+2) (void) time(&t3);
#if defined(_icl_mumbo_jumbo_)
ticksTOTAL = ticksTOTAL + GetRDTSC() - ticksStart;
#endif
	printf("\nInfo1: One second seems to have %s clocks.\n", _ui64toaKAZEcomma((clock()-clocks1)/2, llTOaDigits, 10));	
#if defined(_icl_mumbo_jumbo_)
	printf("Info2: This CPU seems to be working at %s MHz.\n", _ui64toaKAZEcomma(ticksTOTAL/2/1000000, llTOaDigits, 10));	
#endif
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nCopying a %dMB block 1024 times i.e. %dGB READ + %dGB WRITTEN ...\n", 256, 256, 256);
(void) time(&t1);
start = clock();
	for (KT2 = 0; KT2 < 1024; KT2++) {
	memcpy(pointerflush+256*1024*1024, pointerflush, 256*1024*1024);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("memcpy(): (%dMB block); %dMB copied in %d clocks or %.3fMB per clock\n", 256, 1024*( 256 ), (int) duration, (float)1024*( 256 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
goto xxxx;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching a %dMB block 1024 times i.e. %dGB ...\n", 8*(1<<HashSizeInBits)>>20, 8*(1<<HashSizeInBits)>>20);
(void) time(&t1);
start = clock();
	for (KT2 = 0; KT2 < 1024; KT2++)
	for (KT = 0; KT < 8*4*1024*1024; KT=KT+4) {
	// pointerflush is 16bit aligned
	xmm0 = xmmload(pointerflush+(KT+0)*16);
	xmm1 = xmmload(pointerflush+(KT+1)*16);
	xmm2 = xmmload(pointerflush+(KT+2)*16);
	xmm3 = xmmload(pointerflush+(KT+3)*16);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_4XMM128bit: (%dMB block); %dMB fetched in %d clocks or %.3fMB per clock\n", 8*(1<<HashSizeInBits)>>20, 1024*( 8*(1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( 8*(1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching a %dMB block 1024 times i.e. %dGB ...\n", 8*(1<<HashSizeInBits)>>20, 8*(1<<HashSizeInBits)>>20);
(void) time(&t1);
start = clock();
	for (KT2 = 0; KT2 < 1024; KT2++)
	for (KT = 0; KT < 8*4*1024*1024; KT=KT+8) {
	// pointerflush is 64/16 bit aligned
	xmm0 = xmmload(pointerflush+(KT+0)*16);
	xmm1 = xmmload(pointerflush+(KT+1)*16);
	xmm2 = xmmload(pointerflush+(KT+2)*16);
	xmm3 = xmmload(pointerflush+(KT+3)*16);
	xmm4 = xmmload(pointerflush+(KT+4)*16);
	xmm5 = xmmload(pointerflush+(KT+5)*16);
	xmm6 = xmmload(pointerflush+(KT+6)*16);
	xmm7 = xmmload(pointerflush+(KT+7)*16);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_8XMM128bit: (%dMB block); %dMB fetched in %d clocks or %.3fMB per clock\n", 8*(1<<HashSizeInBits)>>20, 1024*( 8*(1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( 8*(1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching a %dMB block 8*1024 times i.e. %dGB ...\n", (1<<HashSizeInBits)>>20, 8*(1<<HashSizeInBits)>>20);
(void) time(&t1);
start = clock();
	for (KT2 = 0; KT2 < 8*1024; KT2++)
	for (KT = 0; KT < 4*1024*1024; KT=KT+4) {
	// pointerflush is 16bit aligned
	xmm0 = xmmload(pointerflush+(KT+0)*16);
	xmm1 = xmmload(pointerflush+(KT+1)*16);
	xmm2 = xmmload(pointerflush+(KT+2)*16);
	xmm3 = xmmload(pointerflush+(KT+3)*16);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_4XMM128bit: (%dMB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 8*1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)8*1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching a %dMB block 8*1024 times i.e. %dGB ...\n", (1<<HashSizeInBits)>>20, 8*(1<<HashSizeInBits)>>20);
(void) time(&t1);
start = clock();
	for (KT2 = 0; KT2 < 8*1024; KT2++)
	for (KT = 0; KT < 4*1024*1024; KT=KT+8) {
	// pointerflush is 64/16 bit aligned
	xmm0 = xmmload(pointerflush+(KT+0)*16);
	xmm1 = xmmload(pointerflush+(KT+1)*16);
	xmm2 = xmmload(pointerflush+(KT+2)*16);
	xmm3 = xmmload(pointerflush+(KT+3)*16);
	xmm4 = xmmload(pointerflush+(KT+4)*16);
	xmm5 = xmmload(pointerflush+(KT+5)*16);
	xmm6 = xmmload(pointerflush+(KT+6)*16);
	xmm7 = xmmload(pointerflush+(KT+7)*16);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_8XMM128bit: (%dMB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 8*1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)8*1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching a %dKB block 4*1024*1024 times i.e. %dGB ...\n", 8*(16*1024)>>10, 4*8*16);
(void) time(&t1);
start = clock();
	for (KT2 = 0; KT2 < 4*1024*1024; KT2++)
	for (KT = 0; KT < 8*4*256; KT=KT+4) {
	// pointerflush is 16bit aligned
	xmm0 = xmmload(pointerflush+(KT+0)*16);
	xmm1 = xmmload(pointerflush+(KT+1)*16);
	xmm2 = xmmload(pointerflush+(KT+2)*16);
	xmm3 = xmmload(pointerflush+(KT+3)*16);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_4XMM128bit: (%dKB block); %dMB fetched in %d clocks or %.3fMB per clock\n", 8*(16*1024)>>10, 4*1024*( 8*(1024*16*1024)>>20 ), (int) duration, (float)4*1024*( 8*(1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching a %dKB block 4*1024*1024 times i.e. %dGB ...\n", 8*(16*1024)>>10, 4*8*16);
(void) time(&t1);
start = clock();
	for (KT2 = 0; KT2 < 4*1024*1024; KT2++)
	for (KT = 0; KT < 8*4*256; KT=KT+8) {
	// pointerflush is 16bit aligned
	xmm0 = xmmload(pointerflush+(KT+0)*16);
	xmm1 = xmmload(pointerflush+(KT+1)*16);
	xmm2 = xmmload(pointerflush+(KT+2)*16);
	xmm3 = xmmload(pointerflush+(KT+3)*16);
	xmm4 = xmmload(pointerflush+(KT+4)*16);
	xmm5 = xmmload(pointerflush+(KT+5)*16);
	xmm6 = xmmload(pointerflush+(KT+6)*16);
	xmm7 = xmmload(pointerflush+(KT+7)*16);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_8XMM128bit: (%dKB block); %dMB fetched in %d clocks or %.3fMB per clock\n", 8*(16*1024)>>10, 4*1024*( 8*(1024*16*1024)>>20 ), (int) duration, (float)4*1024*( 8*(1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching a %dKB block 8*4*1024*1024 times i.e. %dGB ...\n", (16*1024)>>10, 8*4*16);
(void) time(&t1);
start = clock();
	for (KT2 = 0; KT2 < 8*4*1024*1024; KT2++)
	for (KT = 0; KT < 4*256; KT=KT+4) {
	// pointerflush is 16bit aligned
	xmm0 = xmmload(pointerflush+(KT+0)*16);
	xmm1 = xmmload(pointerflush+(KT+1)*16);
	xmm2 = xmmload(pointerflush+(KT+2)*16);
	xmm3 = xmmload(pointerflush+(KT+3)*16);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_4XMM128bit: (%dKB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 8*4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)8*4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching a %dKB block 8*4*1024*1024 times i.e. %dGB ...\n", (16*1024)>>10, 8*4*16);
(void) time(&t1);
start = clock();
	for (KT2 = 0; KT2 < 8*4*1024*1024; KT2++)
	for (KT = 0; KT < 4*256; KT=KT+8) {
	// pointerflush is 16bit aligned
	xmm0 = xmmload(pointerflush+(KT+0)*16);
	xmm1 = xmmload(pointerflush+(KT+1)*16);
	xmm2 = xmmload(pointerflush+(KT+2)*16);
	xmm3 = xmmload(pointerflush+(KT+3)*16);
	xmm4 = xmmload(pointerflush+(KT+4)*16);
	xmm5 = xmmload(pointerflush+(KT+5)*16);
	xmm6 = xmmload(pointerflush+(KT+6)*16);
	xmm7 = xmmload(pointerflush+(KT+7)*16);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_8XMM128bit: (%dKB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 8*4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)8*4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
xxxx:
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching/Hashing a %dMB block 1024 times i.e. %dGB ...\n", (1<<HashSizeInBits)>>20, (1<<HashSizeInBits)>>20);
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	Slot = ( BURST_Read_4DWORDS(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_4DWORDS: (%dMB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	Slot = ( BURST_Read_8DWORDSi(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_8DWORDSi: (%dMB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	XXH_256(pointerflush, (1<<HashSizeInBits), &xxhashstamp);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("XXH_256: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	Slot = ( FNV1A_penumbra(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_penumbra: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIADiiXMM(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIADiiXMM: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIADii(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIADii: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIAD(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIAD: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	Slot = ( FNV1A_farolito(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_farolito: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	Slot = ( FNV1A_Hash_Yorikke(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_Yorikke: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	Slot = ( FNV1A_Hash_Yoshimura(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_Yoshimura: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 1024; KT++) {
	Slot = ( CRC_SlicingBy8K2(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("CRC32_SlicingBy8K2: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching/Hashing a %dMB block 32*1024 times ...\n", (2*1024*1024)>>20);
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	Slot = ( BURST_Read_4DWORDS(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_4DWORDS: (%dMB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	Slot = ( BURST_Read_8DWORDSi(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_8DWORDSi: (%dMB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	XXH_256(pointerflush, 2*1024*1024, &xxhashstamp);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("XXH_256: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	Slot = ( FNV1A_penumbra(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_penumbra: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIADiiXMM(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIADiiXMM: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIADii(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIADii: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIAD(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIAD: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	Slot = ( FNV1A_farolito(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_farolito: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	Slot = ( FNV1A_Hash_Yorikke(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_Yorikke: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	Slot = ( FNV1A_Hash_Yoshimura(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_Yoshimura: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 32*1024; KT++) {
	Slot = ( CRC_SlicingBy8K2(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("CRC32_SlicingBy8K2: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 32*1024*( (2*1024*1024)>>20 ), (int) duration, (float)32*1024*( (2*1024*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching/Hashing a %dKB block 512*1024 times ...\n", (128*1024)>>10);
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	Slot = ( BURST_Read_4DWORDS(pointerflush, 128*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_4DWORDS: (%dKB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	Slot = ( BURST_Read_8DWORDSi(pointerflush, 128*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_8DWORDSi: (%dKB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	XXH_256(pointerflush, 128*1024, &xxhashstamp);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("XXH_256: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	Slot = ( FNV1A_penumbra(pointerflush, 128*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_penumbra: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIADiiXMM(pointerflush, 128*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIADiiXMM: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIADii(pointerflush, 128*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIADii: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIAD(pointerflush, 128*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIAD: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	Slot = ( FNV1A_farolito(pointerflush, 128*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_farolito: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	Slot = ( FNV1A_Hash_Yorikke(pointerflush, 128*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_Yorikke: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	Slot = ( FNV1A_Hash_Yoshimura(pointerflush, 128*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_Yoshimura: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 512*1024; KT++) {
	Slot = ( CRC_SlicingBy8K2(pointerflush, 128*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("CRC32_SlicingBy8K2: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (128*1024)>>10, 512*( (1024*128*1024)>>20 ), (int) duration, (float)512*( (1024*128*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching/Hashing a %dKB block 4*1024*1024 times ...\n", (16*1024)>>10);
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	Slot = ( BURST_Read_4DWORDS(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_4DWORDS: (%dKB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	Slot = ( BURST_Read_8DWORDSi(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_8DWORDSi: (%dKB block); %dMB fetched in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	XXH_256(pointerflush, 16*1024, &xxhashstamp);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("XXH_256: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	Slot = ( FNV1A_penumbra(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_penumbra: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIADiiXMM(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIADiiXMM: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIADii(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIADii: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIAD(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIAD: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	Slot = ( FNV1A_farolito(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_farolito: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	Slot = ( FNV1A_Hash_Yorikke(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_Yorikke: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	Slot = ( FNV1A_Hash_Yoshimura(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_Yoshimura: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 4*1024*1024; KT++) {
	Slot = ( CRC_SlicingBy8K2(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("CRC32_SlicingBy8K2: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 4*1024*( (1024*16*1024)>>20 ), (int) duration, (float)4*1024*( (1024*16*1024)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf("\nFetching/Hashing a %dbytes block 256*1024*1024 times ...\n", (256));
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	Slot = ( BURST_Read_4DWORDS(pointerflush, 256) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_4DWORDS: (%dbytes block); %dMB fetched in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	Slot = ( BURST_Read_8DWORDSi(pointerflush, 256) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("BURST_Read_8DWORDSi: (%dbytes block); %dMB fetched in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	XXH_256(pointerflush, 256, &xxhashstamp);
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("XXH_256: (%dbytes block); %dMB hashed in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	Slot = ( FNV1A_penumbra(pointerflush, 256) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_penumbra: (%dbytes block); %dMB hashed in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIADiiXMM(pointerflush, 256) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIADiiXMM: (%dbytes block); %dMB hashed in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIADii(pointerflush, 256) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIADii: (%dbytes block); %dMB hashed in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	Slot = ( FNV1A_Hash_YoshimitsuTRIAD(pointerflush, 256) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_YoshimitsuTRIAD: (%dbytes block); %dMB hashed in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	Slot = ( FNV1A_farolito(pointerflush, 256) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_farolito: (%dbytes block); %dMB hashed in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	Slot = ( FNV1A_Hash_Yorikke(pointerflush, 256) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_Yorikke: (%dbytes block); %dMB hashed in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	Slot = ( FNV1A_Hash_Yoshimura(pointerflush, 256) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("FNV1A_Yoshimura: (%dbytes block); %dMB hashed in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(void) time(&t1);
start = clock();
	for (KT = 0; KT < 256*1024*1024; KT++) {
	Slot = ( CRC_SlicingBy8K2(pointerflush, 256) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}
printf("CRC32_SlicingBy8K2: (%dbytes block); %dMB hashed in %d clocks or %.3fMB per clock\n", (256), 4*1024*( (1024*256*64)>>20 ), (int) duration, (float)4*1024*( (1024*256*64)>>20 )/ ((int) duration));
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~


	exit(1);

	//for (KT = 0; KT < 256; KT++) {
	//printf("%s\n", _ui64toaKAZEzerocomma(KT, llTOaDigits, 2)+(26-10) );
	//}
	//exit(1);

                        start = clock();

   //printf("\nCode (00508-00270+1=665bytes long compiled with Microsoft V16 32bit /Ox) is being executed, recursive exhaustive depth-first searching ...\n");
   if (Verbose==1) printf("|Sequences(only failures):  |Jumps i.e. knight's moves: |Elapsed seconds:\n");

   // 1 2 3 ... 8   a8 b8 ... h8
   // 9 ...         a7 ...
   // ...      64   ...       h1
   play( (Bunyo2-'A') + (8-(Bunyo1-'1'+1))*8 + 1 );
   printf("\n");
   printf("Total recursions(jumps i.e. knight's moves): %I64d\n", Jumps);
   printf("Total solutions(tours): %I64d\n", wincount);
}

//char BarIndicator[65]; 
unsigned long nTrys_High = 0, nTrys_Low = 0;

void play( int square )
{
  int i;

  Jumps++;
  // nTrys_Low++; if (nTrys_Low == 0) nTrys_High++;

   board[square] = 1;
   moves[k++] = square;

             //for (i=1; i<65;i++) if (i-k>0) BarIndicator[i]=' '; else BarIndicator[i]='#';
             //printf(" [%s]\n", &BarIndicator[1]);

if ((++nTrys_Low & 0x0FFFFFFF) == 0x0FFFFFFF) { // 4x 16 millions
                        finish = clock();
                        duration = (double) (finish - start) / CLOCKS_PER_SEC;
             if (Verbose==1) printf("|%s |%s |%.2f \r", _ui64toaKAZEzerocomma(Sequences, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma(Jumps, llTOaDigits2, 10)+(26-26), duration);
                               }

   if (k == 64)
   {
             wincount++;
                        finish = clock();
                        duration = (double) (finish - start) / CLOCKS_PER_SEC;
             if (Verbose==1) {
                 printf("|%s |%s |%.2f \r", _ui64toaKAZEzerocomma(Sequences, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma(Jumps, llTOaDigits2, 10)+(26-26), duration);
                 winner();
             } else if (Verbose==3) {
                 winner();
                 if ( wincount == KT ) {
                 //printf("|%s |%s |%.2f \r", _ui64toaKAZEzerocomma(Sequences, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma(Jumps, llTOaDigits2, 10)+(26-26), duration);
                 exit(1);
                 }
             } else if (Verbose==2) {
                 winner();
             } else {
             }

      board[square] = 0; k--; return;
   }
   for (i = 0; list[square][i] != 0; i++)
   {
      if (board[list[square][i]] == 0)
         play(list[square][i]);
      else
         if (list[square][i+1] == 0)
         {
         Sequences++;
         if (Verbose==2) winner();
         }
   }
   board[square] = 0; k--; return;


free(pointerflushUNALIGN);

}

void winner( void )
{
   int i;
   int BrutusLet;
   int BrutusPos;
   int BrutusBIN;

     for (i = 0; i < k; i++) {
         //printf( "%c%d", 'A'+( (moves[i]-1)%8+1 )-1, 9-( (moves[i]-1)/8+1 ) );
         KTstring[i*2] = 'A'+( (moves[i]-1)%8+1 )-1;
         KTstring[i*2+1] = '0'+9-( (moves[i]-1)/8+1 );
     }

     //printf("\n");

	KTstring[128] = 0;
	KTstringBRUTUS[128] = 0;
	//printf("%s\n",KTstring);
//	KT_DumpCounter++;

   if (Verbose==1) printf("\n|Sequences(only failures):  |Jumps i.e. knight's moves: |Elapsed seconds:\n");


if (PrintTheFirstKTvariants == 0) {
	printf("The first KT:\n%s\ngives following 64 UNIQUE derivatives:\n",KTstring);
}

	for (BrutusPos = 0; BrutusPos < 64; BrutusPos++) {
/*
	for (BrutusLet = 0; BrutusLet < 32; BrutusLet++) {
	for (BrutusPos = 0; BrutusPos < 64; BrutusPos++) {
		memcpy( KTstringBRUTUS, KTstring, 128 );
		KTstringBRUTUS[BrutusPos*2] = KTstring[BrutusPos*2] - (BrutusLet+1);
		KT_DumpCounter++;
		if (PrintTheFirstKTvariants == 0) {
			printf("%s\n",KTstringBRUTUS);
		}
*/
		memcpy( KTstringBRUTUS, KTstring, 128 );
		KTstringBRUTUS[BrutusPos*2] = KAZE_tolower(KTstring[BrutusPos*2]);
		KT_DumpCounter++;
		if (PrintTheFirstKTvariants == 0) {
			printf("%s\n",KTstringBRUTUS);
		}

	Slot = ( FNV1A_Hash_Yorikke(KTstringBRUTUS, 128) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( CRC_SlicingBy8K1(KTstringBRUTUS, 128) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush2+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush2+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( CRC_SlicingBy8K2(KTstringBRUTUS, 128) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush3+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush3+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( CRC_SlicingBy8C1(KTstringBRUTUS, 128) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush4+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush4+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( CRC_SlicingBy8C2(KTstringBRUTUS, 128) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush5+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush5+Slot, &PseudoLinkedPointer, 4 );

	HASHfreeSLOTS = 0;
	HASHfreeSLOTS2 = 0;
	HASHfreeSLOTS3 = 0;
	HASHfreeSLOTS4 = 0;
	HASHfreeSLOTS5 = 0;
	MAXcollisionsAtSomeSlotsSUM = 0;
	MAXcollisionsAtSomeSlotsSUM2 = 0;
	MAXcollisionsAtSomeSlotsSUM3 = 0;
	MAXcollisionsAtSomeSlotsSUM4 = 0;
	MAXcollisionsAtSomeSlotsSUM5 = 0;
	if ( (KT_DumpCounter & ReportAtEvery) == ReportAtEvery ) {
		for (i = 0; i < 1<<HashSizeInBits; i++) {
			memcpy( &PseudoLinkedPointer, pointerflush+((i)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots ) MAXcollisionsAtSomeSlots = PseudoLinkedPointer;
			memcpy( &PseudoLinkedPointer, pointerflush2+((i)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS2++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots2 ) MAXcollisionsAtSomeSlots2 = PseudoLinkedPointer;
			memcpy( &PseudoLinkedPointer, pointerflush3+((i)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS3++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots3 ) MAXcollisionsAtSomeSlots3 = PseudoLinkedPointer;
			memcpy( &PseudoLinkedPointer, pointerflush4+((i)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS4++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots4 ) MAXcollisionsAtSomeSlots4 = PseudoLinkedPointer;
			memcpy( &PseudoLinkedPointer, pointerflush5+((i)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS5++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots5 ) MAXcollisionsAtSomeSlots5 = PseudoLinkedPointer;
		}
		for (i = 0; i < 1<<HashSizeInBits; i++) {
			memcpy( &PseudoLinkedPointer, pointerflush+((i)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots ) MAXcollisionsAtSomeSlotsSUM++;
			memcpy( &PseudoLinkedPointer, pointerflush2+((i)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots2 ) MAXcollisionsAtSomeSlotsSUM2++;
			memcpy( &PseudoLinkedPointer, pointerflush3+((i)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots3 ) MAXcollisionsAtSomeSlotsSUM3++;
			memcpy( &PseudoLinkedPointer, pointerflush4+((i)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots4 ) MAXcollisionsAtSomeSlotsSUM4++;
			memcpy( &PseudoLinkedPointer, pointerflush5+((i)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots5 ) MAXcollisionsAtSomeSlotsSUM5++;
		}
	printf("FNV1A_Yorikke : KT_derivatives = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-18), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );

	printf("CRC32K1_8slice: KT_derivatives = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-18), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM2, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots2, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS2, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS2)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );
	printf("CRC32K2_8slice: KT_derivatives = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-18), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM3, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots3, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS3, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS3)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );

	printf("CRC32C1_8slice: KT_derivatives = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-18), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM4, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots4, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS4, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS4)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );
	printf("CRC32C2_8slice: KT_derivatives = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-18), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM5, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots5, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS5, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS5)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );
	}

/*
	} //for (BrutusPos...
	} //for (BrutusLet...
*/
	} //for (BrutusPos...

	PrintTheFirstKTvariants = 1;
}


/*

*/